# PyDNS — 2D DNS Viewer (PyQt6 + Fortran)

A lightweight 2D Direct Numerical Simulation (DNS) visualizer using:

- **PyQt6** for the GUI  
- **NumPy + f2py** (Fortran) for the DNS solver  
- Runs on macOS  
- Optional `.app` bundle via PyInstaller  

---

## 🚀 Quick Install (macOS + gcc + uv)

### 1. Install system tools

```bash
brew install uv
brew install gcc
```

- `uv` — Fast Python package manager + virtualenv + runner  
- `gcc` — provides `gfortran` for the Fortran module  

### 2. Install Python and activate it

```bash
git clone git@github.com:mannetroll/pydns.git
cd pydns
uv python install 3.13.9
uv python pin 3.13.9
uv venv --python 3.13.9
source .venv/bin/activate
uv sync
```

---

## 🔧 Build the Fortran extension without OpenMP

If your solver file is `dns_driver_min.f`:

```bash
cd fortran
bash build_dns_macos.sh
```

This produces:

```
dns_fortran.cpython-313-darwin.so
```

---

## ▶ Run the DNS Viewer

![DNS Viewer Window](https://github.com/mannetroll/pydns/raw/main/window.png)

```bash
uv run python main_min.py
```

---

Build Wheel:

```bash
uv build
```

Produces:

```
dist/pydns-0.1.1-cp313-cp313-macosx_15_0_arm64.whl
```

## 🖥 Build a macOS `.app`

The project includes `pydns.spec`.

Build the bundle:

```bash
uv run pyinstaller pydns.spec
```

Produces:

```
dist/pydns.app
```

Double-click to launch.

## twine & pypi.org

```
uv add --dev build twine
uv run python -m build
uv run twine upload dist/*
```

## one-liner

```
curl -LsSf https://astral.sh/uv/install.sh | sh
uv run --with mannetroll-pydns==0.1.2 python -m main_min
```

---

C	SUBROUTINE VISASUB3D
C********1*********2*********3*********4*********5*********6*********7**
C	IMPLICIT NONE
C	INCLUDE 'parameter3.f'
C	INCLUDE 'variabel3.f'
C
C*********************************MAIN**********************************
C	IF(IT.EQ.0)THEN
C	   CALL READINPUT(T0,T,IT,CN,CNM1,CFLNUM,TMAX,
C    &                  ITMAX,IFN,K0,RE)
C	   CALL PAO(UC,ALFA,GAMMA,NX,NX,RE,K0,VISC)
C	   CALL INIT(NX,NZ,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
C	   CALL CALCOM(NX,NZ,ALFA,GAMMA,UC,OM2)
C	END IF
C
C	CALL STEP2A(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ) !Non-linear
C	IF(IFN.NE.0)CALL NEXTDT(NX,NZ,UR,CFLNUM,IT,IFN,DT,CN)
C	CALL STEP2B(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ) !Non-linear
C	CALL STEP3(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ,
C    &           OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1) !One-diagonal
C	WRITE(*,'(I4,A,F12.9)')IT,'  T = ',T
C
C	RETURN
C	END
C*********************************************************************
C*******************************SUBBS*********************************
C*********************************************************************
      SUBROUTINE READINPUT(T0,T,IT,CN,CNM1,CFLNUM,TMAX,ITMAX,IFN,K0,RE)
      IMPLICIT NONE
      INTEGER IT,ITMAX,IFN
      REAL    T0,T,TMAX,DT,CN,CNM1,CFLNUM,K0,RE
      T0=0
      T=T0
      IT=0
      CN=1
      CNM1=0
      CFLNUM=0.7
      TMAX=10
      DT=0
      ITMAX=10000
      IFN=1
      K0=10
      RE=500
      RETURN
      END			!READINPUT
C*********************************************************************
      SUBROUTINE INIT(NX,NZ,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
      IMPLICIT NONE
      INTEGER   NX,NZ
      COMPLEX   NOLL
      PARAMETER (NOLL=(0.00,0.00))
      COMPLEX   FNM1(NX/2,NZ)
      REAL      ALFA(NX/2),GAMMA(NZ)
      REAL      PREX(3*NX/2+15,4),PREZ(3*NZ+15,4),WSAVE(NX+15)
      INTEGER   X,Z,I
C  Per-component FFT init
      DO 10 I=1,4
         CALL VRFFTI(3*NX/2,PREX(1,I),0)
         CALL VCFFTI(3*NZ/2,PREZ(1,I),0)
 10   CONTINUE
      CALL VRFFTI(NX,WSAVE,0)
      DO 200 X=1,NX/2
         ALFA(X)=FLOAT(X-1)
 200  CONTINUE
      GAMMA(1)=0.
      DO 300 Z=2,NZ/2+1
         GAMMA(Z)=FLOAT(Z-1)
         GAMMA(NZ+2-Z)=-GAMMA(Z)
 300  CONTINUE
      DO 400 X=1,NX/2
         DO 500 Z=1,NZ
            FNM1(X,Z)=NOLL
 500     CONTINUE
 400  CONTINUE
      RETURN
      END			!INIT

C*************************************************************
      SUBROUTINE CALCOM(NX,NZ,ALFA,GAMMA,UC,OM2)
      IMPLICIT NONE
      INTEGER NX,NZ
      COMPLEX UC(3*NX/4+1,3*NZ/2,3),OM2(NX/2,NZ)
      REAL ALFA(NX/2),GAMMA(NZ)
      COMPLEX IM
      PARAMETER (IM=(0.00,1.00))
      INTEGER X,Z
C       calculate omega2_th spectrally
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(X,Z)
      DO 100 Z=1,NZ
         DO 110 X=1,NX/2
            OM2(X,Z)=IM*(GAMMA(Z)*UC(X,Z,1)-ALFA(X)*UC(X,Z,2))
 110     CONTINUE
 100  CONTINUE
C$OMP END PARALLEL DO

      RETURN
      END			!CALCOM

C***********************************************************************
      SUBROUTINE STEP2A(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)
      IMPLICIT NONE
      INTEGER NX,NZ
      COMPLEX UC(3*NX/4+1,3*NZ/2,3)
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      COMPLEX   NOLL
      PARAMETER (NOLL=(0.00,0.00))
      INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)

C       reshuffle and insert zeros in a-g-plane
      DO 100 I=1,2
         DO 110 Z=1,3*NZ/2
            DO 120 X=NX/2+1,3*NX/4+1
               UC(X,Z,I)=NOLL
 120        CONTINUE
 110     CONTINUE
 100  CONTINUE

      DO 200 I=1,2
         DO 210 Z=1,NZ/2
            DO 220 X=1,NX/2
               UC(X,Z+NZ,I)=UC(X,Z+NZ/2,I)
               UC(X,Z+NZ/2,I)=NOLL
 220        CONTINUE
 210     CONTINUE
 200  CONTINUE

C       transform ui_h to phys space
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(I)
      DO 500 I=1,2
         CALL VCFFTB(UR(1,1,I),UR(2,1,I),
     &               TFFTXZ(1,1,I),TFFTXZ(2,1,I),
     &               3*NZ/2,NX/2,3*NX/2+2,2,PREZ(1,I))
         CALL VRFFTB(UR(1,1,I),UR(2,1,I),
     &               TFFTXZ(1,1,I),TFFTXZ(2,1,I),
     &               3*NX/2,3*NZ/2,2,3*NX/2+2,PREX(1,I))
 500  CONTINUE
C$OMP END PARALLEL DO
C       ui now real and stored in UR(,,i)

      RETURN
      END

C***********************************************************************
      SUBROUTINE STEP2B(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)
      IMPLICIT NONE
      INTEGER NX,NZ
      COMPLEX UC(3*NX/4+1,3*NZ/2,3)
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      COMPLEX   NOLL
      PARAMETER (NOLL=(0.00,0.00))
      INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)
C
C       calculate uiuj and put into UR(x,z,1-3)
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(X,Z)
      DO 700 Z=1,3*NZ/2
         DO 710 X=1,3*NX/2
            UR(X,Z,3)=UR(X,Z,1)*UR(X,Z,2)
            UR(X,Z,1)=UR(X,Z,1)*UR(X,Z,1)
            UR(X,Z,2)=UR(X,Z,2)*UR(X,Z,2)
 710     CONTINUE
 700  CONTINUE
C$OMP END PARALLEL DO

C       transform uiuj back to a-g space, i.e. to uiuj_th
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(I)
      DO 800 I=1,3
         CALL VRFFTF(UR(1,1,I),UR(2,1,I),
     &               TFFTXZ(1,1,I),TFFTXZ(2,1,I),
     &               3*NX/2,3*NZ/2,2,3*NX/2+2,PREX(1,I))
         CALL VCFFTF(UR(1,1,I),UR(2,1,I),
     &               TFFTXZ(1,1,I),TFFTXZ(2,1,I),
     &               3*NZ/2,NX/2,3*NX/2+2,2,PREZ(1,I))
 800  CONTINUE
C$OMP END PARALLEL DO

C       put the 'extra' fourier coeff. to zero (the middle one)
      DO 900 I=1,3
         DO 910 X=1,NX/2
            UC(X,NZ+1,I)=NOLL
 910     CONTINUE
 900  CONTINUE

      RETURN
      END			!STEP2
C***********************************************************************
      SUBROUTINE STEP3(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ,
     &                 OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1)
      IMPLICIT NONE
      INTEGER NX,NZ
      COMPLEX UC(3*NX/4+1,3*NZ/2,3),OM2(NX/2,NZ),FNM1(NX/2,NZ)
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      REAL ALFA(NX/2),GAMMA(NZ)
      COMPLEX   NOLL,IM
      PARAMETER (NOLL=(0.00,0.00),IM=(0.00,1.00))
      COMPLEX FN
      REAL DIVXZ,K2,VT,VISC,T,DT,CN,CNM1
      INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)
C
C       solve for omega2_th, u_th and w_th
C       in the first timestep FNM1=0 and the eulerstep is DT0

      DIVXZ=1./(FLOAT(3*NX/2)*FLOAT(3*NZ/2))
      VT=0.5*VISC*DT

C     lower half Z=1..NZ/2
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(X,Z,FN,K2)
      DO 100 Z=1,NZ/2
         DO 110 X=1,NX/2
            FN=(GAMMA(Z)*ALFA(X)*(UC(X,Z,1)-UC(X,Z,2))+
     &           UC(X,Z,3)*(GAMMA(Z)**2-ALFA(X)**2))*DIVXZ
            K2=(ALFA(X)**2+GAMMA(Z)**2)
            OM2(X,Z)=(OM2(X,Z)*(1-VT*K2)+
     &             DT*0.5*((2+CNM1)*FN-CNM1*FNM1(X,Z)))/(1+VT*K2)
            FNM1(X,Z)=FN	!save fn for next time step
 110     CONTINUE
 100  CONTINUE
C$OMP END PARALLEL DO

C     upper half Z=NZ/2+1..NZ
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(X,Z,FN,K2)
      DO 200 Z=NZ/2+1,NZ
         DO 210 X=1,NX/2
            FN=(GAMMA(Z)*ALFA(X)*(UC(X,Z+NZ/2,1)-UC(X,Z+NZ/2,2))+
     &           UC(X,Z+NZ/2,3)*(GAMMA(Z)**2-ALFA(X)**2))*DIVXZ
            K2=(ALFA(X)**2+GAMMA(Z)**2)
            OM2(X,Z)=(OM2(X,Z)*(1-VT*K2)+
     &             DT*0.5*((2+CNM1)*FN-CNM1*FNM1(X,Z)))/(1+VT*K2)
            FNM1(X,Z)=FN	!save fn for next time step
 210     CONTINUE
 200  CONTINUE
C$OMP END PARALLEL DO

      CNM1=CN                 !save cn for next time step

C     X >= 2 part
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(X,Z,K2)
      DO 300 Z=1,NZ
         DO 310 X=2,NX/2
            K2=(ALFA(X)**2+GAMMA(Z)**2)
            UC(X,Z,1)=-IM*GAMMA(Z)*OM2(X,Z)/K2
            UC(X,Z,2)=IM*ALFA(X)*OM2(X,Z)/K2
 310     CONTINUE
 300  CONTINUE
C$OMP END PARALLEL DO

C     X = 1 special case
C$OMP PARALLEL DO DEFAULT(SHARED) PRIVATE(Z)
      DO 400 Z=2,NZ           !X=1
         UC(1,Z,1)=-IM*OM2(1,Z)/GAMMA(Z)
         UC(1,Z,2)=NOLL
 400  CONTINUE
C$OMP END PARALLEL DO

      UC(1,1,1)=NOLL
      UC(1,1,2)=NOLL
      T=T+DT

      RETURN
      END			!STEP3

C***********************************************************************
      SUBROUTINE NEXTDT(NX,NZ,UR,CFLNUM,IT,IFN,DT,CN)
      IMPLICIT NONE
      INTEGER NX,NZ,IT,IFN
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL PI,CFLM,DX,DZ,CFL,CFLNUM,DT,CN
      PARAMETER (PI=3.14159265358979)
      INTEGER X,Z
C       calculates the next time step
      CFLM=0

      IF((IT.EQ.0).AND.(DT.EQ.0))THEN
        DX=2*PI/FLOAT(NX)
        DZ=2*PI/FLOAT(NZ)
        DO 100 Z=1,3*NZ/2
          DO 110 X=1,3*NX/2
            CFLM=MAX(CFLM,ABS(UR(X,Z,1))/DX+ABS(UR(X,Z,2))/DZ)
 110      CONTINUE
 100    CONTINUE
        DT=CFLNUM/CFLM/PI
        RETURN
      END IF

      IF(MOD(IT,IFN).EQ.0)THEN
        DX=2*PI/FLOAT(NX)
        DZ=2*PI/FLOAT(NZ)
        DO 200 Z=1,3*NZ/2
          DO 210 X=1,3*NX/2
            CFLM=MAX(CFLM,ABS(UR(X,Z,1))/DX+ABS(UR(X,Z,2))/DZ)
 210      CONTINUE
 200    CONTINUE
        CFL=CFLM*DT*PI
        CN=0.8+0.2*CFLNUM/CFL
        DT=DT*CN
        RETURN
      END IF

      RETURN
      END			!NEXTDT
C***********************************************************************
      SUBROUTINE FIELD2PIX(PIXARR,PX,PY,UR,ENFAC,NX3D2,NZ3D2,AXIS)
      IMPLICIT NONE
      INTEGER  NX3D2, NZ3D2, PX, PY, SIZE, AXIS
      REAL     UR(NX3D2+2,NZ3D2,3)
      INTEGER  PIXARR(PX,PY)
      INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
      REAL     ENFAC
C
C     32-bit Grayscale
C
      GRAY  = (1+256+65536)
      SCALE = MIN(PX/NX3D2,PY/NZ3D2)
      DO I=1,NX3D2
        DO J=1,NZ3D2
          PIXEL = MAX(1,MIN(255,(INT(ENFAC*UR(I,J,AXIS))+128)))*GRAY
          DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
            DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
              PIXARR(II,JJ) = PIXEL
            END DO
          END DO
        END DO
      END DO

      RETURN
      END			!FIELD2PIX

C***********************************************************************
      SUBROUTINE FIELD2KIN(PIXARR,PX,PY,UR,KEFAC,NX3D2,NZ3D2)
      IMPLICIT NONE
      INTEGER  NX3D2, NZ3D2, PX, PY, SIZE
      REAL     UR(NX3D2+2,NZ3D2,3)
      INTEGER  PIXARR(PX,PY)
      INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
      REAL     KEFAC, U2, W2, K
C
C     32-bit Grayscale
C
      GRAY  = (1+256+65536)
      SCALE = MIN(PX/NX3D2,PY/NZ3D2)
      DO I=1,NX3D2
        DO J=1,NZ3D2
          U2 = UR(I,J,1)**2
          W2 = UR(I,J,2)**2
          K  = SQRT(U2+W2)
          PIXEL = MAX(1,MIN(255,(INT(KEFAC*K))))*GRAY
          DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
            DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
              PIXARR(II,JJ) = PIXEL
            END DO
          END DO
        END DO
      END DO

      RETURN
      END			!FIELD2KIN

C***********************************************************************
      SUBROUTINE OM2PHYS(NX,NZ,UC,UR,OM2,TFFTXZ,PREX,PREZ)
      IMPLICIT NONE
      INTEGER NX,NZ
      COMPLEX OM2(NX/2,NZ)
      COMPLEX UC(3*NX/4+1,3*NZ/2,3)
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      COMPLEX   NOLL
      PARAMETER (NOLL=(0.00,0.00))
      INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C     Copy omega
      DO 10 Z=1,NZ
        DO 20 X=1,NX/2
          UC(X,Z,3) = OM2(X,Z)
 20     CONTINUE
 10   CONTINUE

C     reshuffle and insert zeros in a-g-plane
      DO 110 Z=1,3*NZ/2
        DO 120 X=NX/2+1,3*NX/4+1
          UC(X,Z,3) = NOLL
 120    CONTINUE
 110  CONTINUE

      DO 210 Z=1,NZ/2
        DO 220 X=1,NX/2
          UC(X,Z+NZ,3)   = UC(X,Z+NZ/2,3)
          UC(X,Z+NZ/2,3) = NOLL
 220    CONTINUE
 210  CONTINUE

      DO 910 X=1,NX/2
        UC(X,NZ+1,3)=NOLL
 910  CONTINUE

C       transform omega to phys space
      CALL VCFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ(1,1,3),TFFTXZ(2,1,3),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ(1,3))
      CALL VRFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ(1,1,3),TFFTXZ(2,1,3),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX(1,3))

      RETURN
      END			!OM2PHYS

C***********************************************************************
      SUBROUTINE FIELD2PHI(PIXARR,PX,PY,UR,OMFAC,NX3D2,NZ3D2,AXIS)
      IMPLICIT NONE
      INTEGER  NX3D2, NZ3D2, PX, PY, SIZE, AXIS
      REAL     UR(NX3D2+2,NZ3D2,3)
      INTEGER  PIXARR(PX,PY)
      INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
      REAL     OMFAC
C
C     32-bit Grayscale
C
      GRAY  = (1+256+65536)
      SCALE = MIN(PX/NX3D2,PY/NZ3D2)
      DO I=1,NX3D2
        DO J=1,NZ3D2
          PIXEL = MAX(1,MIN(255,(INT(OMFAC*UR(I,J,AXIS)))))*GRAY
          DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
            DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
              PIXARR(II,JJ) = PIXEL
            END DO
          END DO
        END DO
      END DO

      RETURN
      END			!FIELD2OMG

C***********************************************************************
      SUBROUTINE PHIPHYS(NX,NZ,ALFA,GAMMA,UC,UR,TFFTXZ,PREX,PREZ)
      IMPLICIT NONE
      INTEGER NX,NZ
      REAL ALFA(NX/2),GAMMA(NZ)
      COMPLEX UC(3*NX/4+1,3*NZ/2,3)
      REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      REAL K2
      COMPLEX   NOLL, IM
      PARAMETER (NOLL=(0.00,0.00))
      PARAMETER (IM=(0.00,1.00))
      INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C     Calculate phi
      DO 10 Z=2,NZ
        DO 20 X=2,NX/2
          UC(X,Z,3) = -IM/(2*ALFA(X)*GAMMA(Z))*
     &                (GAMMA(Z)*UC(X,Z,1) + ALFA(X)*UC(X,Z,2))
 20     CONTINUE
 10   CONTINUE
      UC(1,1,3)=NOLL

      DO 30 X=2,NX/2
        UC(X,1,3) = -IM/ALFA(X)*UC(X,1,1)
 30   CONTINUE

      DO 40 Z=2,NZ
        UC(1,Z,3) = -IM/GAMMA(Z)*UC(1,Z,2)
 40   CONTINUE

C     reshuffle and insert zeros in a-g-plane
      DO 110 Z=1,3*NZ/2
        DO 120 X=NX/2+1,3*NX/4+1
          UC(X,Z,3) = NOLL
 120    CONTINUE
 110  CONTINUE

      DO 210 Z=1,NZ/2
        DO 220 X=1,NX/2
          UC(X,Z+NZ,3)   = UC(X,Z+NZ/2,3)
          UC(X,Z+NZ/2,3) = NOLL
 220    CONTINUE
 210  CONTINUE

      DO 910 X=1,NX/2
        UC(X,NZ+1,3)=NOLL
 910  CONTINUE

C       transform phi to phys space
      CALL VCFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ(1,1,3),TFFTXZ(2,1,3),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ(1,3))
      CALL VRFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ(1,1,3),TFFTXZ(2,1,3),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX(1,3))

      RETURN
      END			!PHIPHYS
C***********************************************************************
      SUBROUTINE STREAMFUNC(NX,NZ,ALFA,GAMMA,UC,UR,OM2,TFFTXZ,PREX,PREZ)
      IMPLICIT NONE
      INTEGER NX,NZ
      REAL ALFA(NX/2),GAMMA(NZ)
      COMPLEX OM2(NX/2,NZ)
      COMPLEX UC(3*NX/4+1,3*NZ/2,4)
      REAL UR(3*NX/2+2,3*NZ/2,4)
      REAL      TFFTXZ(3*NX/2+2,3*NZ/2,4),PREX(3*NX/2+15,4),PREZ(3*NZ+15,4)
      REAL K2
      COMPLEX   NOLL, IM
      PARAMETER (NOLL=(0.00,0.00))
      PARAMETER (IM=(0.00,1.00))
      INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C     Calculate Streamfunction
      DO 10 Z=1,NZ
        DO 20 X=1,NX/2
          K2 = ALFA(X)**2 + GAMMA(Z)**2
          UC(X,Z,4) = OM2(X,Z)/(K2 + 1.0E-30)
 20     CONTINUE
 10   CONTINUE
      UC(1,1,4)=NOLL

C     reshuffle and insert zeros in a-g-plane
      DO 110 Z=1,3*NZ/2
        DO 120 X=NX/2+1,3*NX/4+1
          UC(X,Z,4) = NOLL
 120    CONTINUE
 110  CONTINUE

      DO 210 Z=1,NZ/2
        DO 220 X=1,NX/2
          UC(X,Z+NZ,4)   = UC(X,Z+NZ/2,4)
          UC(X,Z+NZ/2,4) = NOLL
 220    CONTINUE
 210  CONTINUE

      DO 910 X=1,NX/2
        UC(X,NZ+1,4)=NOLL
 910  CONTINUE

C       transform streamfunction to phys space
      CALL VCFFTB(UR(1,1,4),UR(2,1,4),TFFTXZ(1,1,4),TFFTXZ(2,1,4),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ(1,4))
      CALL VRFFTB(UR(1,1,4),UR(2,1,4),TFFTXZ(1,1,4),TFFTXZ(2,1,4),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX(1,4))

      RETURN
      END			!STREAMFUNC

C***********************************************************************
C  dns_driver_min3d.f  —  Workspace + callable DNS API for Python (f2py)
C  Works with: pao.f, vfft.f, visasub3d.f, dns_fortran_min.pyf
C***********************************************************************

      MODULE DNS_WORKSPACE
      IMPLICIT NONE
C--- Global limits -----------------------------------------------------
      INTEGER, PARAMETER :: NMAX = 256

C--- Global scalar state -----------------------------------------------
      INTEGER, SAVE :: N, N3D2, PX, PY, IT, IFN
      REAL,    SAVE :: RE, K0, VISC, T, DT, CN, CNM1, CFLNUM

C--- Global arrays (workspace) -----------------------------------------
C  Note: 3D FFT workspaces and 4-component UC/UR to match visasub3d.f
      COMPLEX, SAVE :: UC(1+3*NMAX/4,3*NMAX/2,4)
      COMPLEX, SAVE :: OM2(NMAX/2,NMAX)
      COMPLEX, SAVE :: FNM1(NMAX/2,NMAX)
      REAL,    SAVE :: ALFA(NMAX/2), GAMMA(NMAX)

      REAL,    SAVE :: TFFTXZ(2+3*NMAX/2,3*NMAX/2,4)
      REAL,    SAVE :: PREX(15+3*NMAX/2,4)
      REAL,    SAVE :: PREZ(15+3*NMAX,4)
      REAL,    SAVE :: WSAVE(15+NMAX)

      REAL,    SAVE :: UR(2+3*NMAX/2,3*NMAX/2,4)

C--- Legacy data layout: UC and UR share storage -----------------------
      EQUIVALENCE (UC,UR)

      END MODULE DNS_WORKSPACE
C=======================================================================


C=======================================================================
C  DNS_INIT  --  initialize full DNS state in module workspace
C=======================================================================
      SUBROUTINE DNS_INIT(NIN,REIN,K0IN)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NIN
      REAL    REIN,K0IN

C--- Set problem size & parameters -------------------------------------
      N     = NIN
      RE    = REIN
      K0    = K0IN
      VISC  = 1.0/RE
      T     = 0.0
      DT    = 0.0
      CN    = 1.0
      CNM1  = 0.0
      CFLNUM= 0.75
      IT    = 0
      IFN   = 1
      N3D2  = 3*N/2
      PX    = 2*N3D2
      PY    = 2*N3D2

C--- Zero work arrays just in case -------------------------------------
      UR      = 0.0
      UC      = (0.0,0.0)
      OM2     = (0.0,0.0)
      FNM1    = (0.0,0.0)
      ALFA    = 0.0
      GAMMA   = 0.0
      TFFTXZ  = 0.0
      PREX    = 0.0
      PREZ    = 0.0
      WSAVE   = 0.0

C--- Original initialization sequence ----------------------------------
      WRITE(*,*) '--- DNS_INIT called ---'

      CALL PAO(UC,ALFA,GAMMA,N,N,RE,K0,VISC)
      WRITE(*,*) 'N=',N
      WRITE(*,*) 'After PAO: VISC=',VISC
      WRITE(*,*) '  Max |UC|=',MAXVAL(ABS(UC))

      CALL INIT(N,N,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
      WRITE(*,*) 'After INIT  Max(ALFA)=',MAXVAL(ALFA),
     &           ' Max(GAMMA)=',MAXVAL(GAMMA)

      CALL CALCOM(N,N,ALFA,GAMMA,UC,OM2)
      WRITE(*,*) 'After CALCOM  Max |OM2|=',MAXVAL(ABS(OM2))

      CALL STEP2A(N,N,UC,UR,TFFTXZ,PREX,PREZ)
      WRITE(*,*) 'Max |UC| before STEP2A =', MAXVAL(ABS(UC))
      WRITE(*,*) 'Max |UR| after STEP2A  =', MAXVAL(ABS(UR))

      CALL NEXTDT(N,N,UR,CFLNUM,IT,IFN,DT,CN)
      WRITE(*,*) 'Initial DT=',DT,' CN=',CN

      RETURN
      END SUBROUTINE DNS_INIT
C=======================================================================


C=======================================================================
C  DNS_STEP  --  advance one timestep using current workspace
C=======================================================================
      SUBROUTINE DNS_STEP(TOUT,DTOUT,CNOUT)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      REAL TOUT,DTOUT,CNOUT

      IT = IT + 1

      CALL STEP2B(N,N,UC,UR,TFFTXZ,PREX,PREZ)
      CALL STEP3(N,N,UC,UR,TFFTXZ,PREX,PREZ,
     &           OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1)
      CALL STEP2A(N,N,UC,UR,TFFTXZ,PREX,PREZ)
      CALL NEXTDT(N,N,UR,CFLNUM,IT,IFN,DT,CN)

      TOUT  = T
      DTOUT = DT
      CNOUT = CN

      RETURN
      END SUBROUTINE DNS_STEP
C=======================================================================


C=======================================================================
C  DNS_FRAME  --  Fill a pixarr(nx,ny) supplied from Python
C=======================================================================
      SUBROUTINE DNS_FRAME(PIXARR,NPX,NPY,COMP)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NPX,NPY,COMP
      INTEGER PIXARR(NPX,NPY)

C  Simple visualization via FIELD2PIX
C  We assume NPX,NPY are at least PX,PY; we use PX,PY from workspace.
      CALL FIELD2PIX(PIXARR, PX, PY, UR, 75.0, N3D2, N3D2, COMP)

      RETURN
      END SUBROUTINE DNS_FRAME
C=======================================================================


C=======================================================================
C  DNS_KINETIC  --  Fill a pixarr(nx,ny) supplied from Python
C=======================================================================
      SUBROUTINE DNS_KINETIC(PIXARR,NPX,NPY)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NPX,NPY
      INTEGER PIXARR(NPX,NPY)

C  Simple visualization via FIELD2KIN
      CALL FIELD2KIN(PIXARR, PX, PY, UR, 125.0, N3D2, N3D2)

      RETURN
      END SUBROUTINE DNS_KINETIC
C=======================================================================


C=======================================================================
C  DNS_OM2PHYS -- Fill a pixarr(nx,ny) supplied from Python
C=======================================================================
      SUBROUTINE DNS_OM2PHYS(PIXARR,NPX,NPY)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NPX,NPY
      INTEGER PIXARR(NPX,NPY)

C  Transform omega to physical space (into UR(:,:,3)) then plot
      CALL OM2PHYS(N, N, UC, UR, OM2, TFFTXZ, PREX, PREZ)
      CALL FIELD2PIX(PIXARR, PX, PY, UR, 7.0, N3D2, N3D2, 3)

      RETURN
      END SUBROUTINE DNS_OM2PHYS
C=======================================================================


C=======================================================================
C  DNS_STREAMFUNC -- Fill a pixarr(nx,ny) supplied from Python
C=======================================================================
      SUBROUTINE DNS_STREAMFUNC(PIXARR,NPX,NPY)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NPX,NPY
      INTEGER PIXARR(NPX,NPY)

C  Compute streamfunction in UC(:,:,4) / UR(:,:,4), then visualize
      CALL STREAMFUNC(N,N,ALFA,GAMMA,UC,UR,OM2,TFFTXZ,PREX,PREZ)
C  Axis=4 here: streamfunction component
      CALL FIELD2PIX(PIXARR,PX,PY,UR,200.0,N3D2,N3D2,4)

      RETURN
      END SUBROUTINE DNS_STREAMFUNC
C=======================================================================


C=======================================================================
C  TEST_DNS  --  standalone diagnostic harness (local workspace)
C=======================================================================
      SUBROUTINE TEST_DNS()
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NLOCAL, N3D2L, PXL, PYL
      PARAMETER (NLOCAL = 128)
      PARAMETER (N3D2L = 3*NLOCAL/2)
      PARAMETER (PXL = N3D2L*2)
      PARAMETER (PYL = N3D2L*2)

C-- Local work arrays ---------------------------------------------------
      COMPLEX   OM2L(NLOCAL/2,NLOCAL)
      COMPLEX   FNM1L(NLOCAL/2,NLOCAL)
      REAL      ALFAL(NLOCAL/2), GAMMAL(NLOCAL)

      REAL      TFFTXZL(2+3*NLOCAL/2,3*NLOCAL/2,4)
      REAL      PREXL(15+3*NLOCAL/2,4)
      REAL      PREZL(15+3*NLOCAL,4)
      REAL      WSAVEL(15+NLOCAL)
      INTEGER   PIXARRL(PXL,PYL)

C-- Scalars -------------------------------------------------------------
      REAL      REL, K0L, VISCL, TL, DTL, CNL, CNM1L, CFLNUML
      INTEGER   ITL, IFNL, NEL

      NEL     = NLOCAL
      REL     = 1000.0
      K0L     = 10.0
      VISCL   = 1.0/REL
      TL      = 0.0
      DTL     = 0.0
      CNL     = 1.0
      CNM1L   = 0.0
      CFLNUML = 0.75
      ITL     = 0
      IFNL    = 1

      WRITE(*,*) '--- INITIALIZING DNS (TEST_DNS) ---'
      WRITE(*,*) 'NLOCAL=',NLOCAL

      CALL PAO(UC,ALFAL,GAMMAL,NLOCAL,NEL,REL,K0L,VISCL)
      WRITE(*,*) 'After PAO: VISC=',VISCL
      WRITE(*,*) '  Max |UC|=',MAXVAL(ABS(UC))

      CALL INIT(NLOCAL,NLOCAL,ALFAL,GAMMAL,FNM1L,PREXL,PREZL,WSAVEL)
      WRITE(*,*) 'After INIT  Max(ALFA)=',MAXVAL(ALFAL),
     &           ' Max(GAMMA)=',MAXVAL(GAMMAL)

      CALL CALCOM(NLOCAL,NLOCAL,ALFAL,GAMMAL,UC,OM2L)
      WRITE(*,*) 'After CALCOM  Max |OM2|=',MAXVAL(ABS(OM2L))

      CALL STEP2A(NLOCAL,NLOCAL,UC,UR,TFFTXZL,PREXL,PREZL)
      WRITE(*,*) 'Max |UC| before STEP2A =', MAXVAL(ABS(UC))
      WRITE(*,*) 'Max |UR| after STEP2A  =', MAXVAL(ABS(UR))

      CALL NEXTDT(NLOCAL,NLOCAL,UR,CFLNUML,ITL,IFNL,DTL,CNL)
      WRITE(*,*) 'Initial DT=',DTL,' CN=',CNL

      DO ITL=1,10
         CALL STEP2B(NLOCAL,NLOCAL,UC,UR,TFFTXZL,PREXL,PREZL)
         CALL STEP3(NLOCAL,NLOCAL,UC,UR,TFFTXZL,PREXL,PREZL,
     &              OM2L,ALFAL,GAMMAL,FNM1L,VISCL,TL,DTL,CNL,CNM1L)
         CALL STEP2A(NLOCAL,NLOCAL,UC,UR,TFFTXZL,PREXL,PREZL)
         CALL NEXTDT(NLOCAL,NLOCAL,UR,CFLNUML,ITL,IFNL,DTL,CNL)
         WRITE(*,*) 'Step',ITL,' T=',TL,' DT=',DTL,' CN=',CNL
      END DO

      CALL FIELD2PIX(PIXARRL,PXL,PYL,UR,75.0,N3D2L,N3D2L,1)
      CALL FIELD2KIN(PIXARRL,PXL,PYL,UR,125.0,N3D2L,N3D2L)
      CALL OM2PHYS(NLOCAL,NLOCAL,UC,UR,OM2L,TFFTXZL,PREXL,PREZL)
      CALL STREAMFUNC(NLOCAL,NLOCAL,ALFAL,GAMMAL,UC,UR,OM2L,
     &                TFFTXZL,PREXL,PREZL)
      CALL FIELD2PIX(PIXARRL,PXL,PYL,UR,75.0,N3D2L,N3D2L,4)

      WRITE(*,*) 'Pixels sample:',PIXARRL(1,1),PIXARRL(NLOCAL,NLOCAL)
      WRITE(*,*) 'Final T=',TL,' CN=',CNL,' DT=',DTL,' VISC=',VISCL
      WRITE(*,*) 'Final Max |UR|=',MAXVAL(ABS(UR))
      WRITE(*,*) 'Final Max |OM2|=',MAXVAL(ABS(OM2L))
      WRITE(*,*) 'Final Max |PIXARR|=',MAXVAL(ABS(PIXARRL))
      RETURN
      END SUBROUTINE TEST_DNS
C=======================================================================


C=======================================================================
C  RUN_DNS  --  simple entry point kept for backward compatibility
C=======================================================================
      SUBROUTINE RUN_DNS(REIN,K0IN)
      IMPLICIT NONE
      REAL    REIN,K0IN

C  Current implementation just calls TEST_DNS and ignores arguments.
C  This preserves the behaviour you had when calling:
C      dns_fortran.run_dns(1000.0,10.0)
      CALL TEST_DNS()
      RETURN
      END SUBROUTINE RUN_DNS
C=======================================================================


C=======================================================================
C  DNS_SNAPSHOT  --  copy UR(:,:,COMP) into a 2D REAL plane for Python
C=======================================================================
      SUBROUTINE DNS_SNAPSHOT(PLANE,NX,NY,COMP)
      USE DNS_WORKSPACE
      IMPLICIT NONE
      INTEGER NX,NY,COMP
      REAL    PLANE(NX,NY)
      INTEGER I,J

C  No checks, assume NX,NY match 2+3*N/2 and 3*N/2
      DO J = 1, NY
         DO I = 1, NX
            PLANE(I,J) = UR(I,J,COMP)
         END DO
      END DO

      RETURN
      END SUBROUTINE DNS_SNAPSHOT
C=======================================================================

      SUBROUTINE VCFFTB (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N
      REAL CR(1+INC*(N-1)+JMP*(M-1)),CI(1+INC*(N-1)+JMP*(M-1))
      REAL WR(1+INC*(N-1)+JMP*(M-1)),WI(1+INC*(N-1)+JMP*(M-1))
      REAL WSAVE(15+2*N)
      IF (N .EQ. 1) RETURN
      CALL CFFTB1 (CR,CI,WR,WI,M,N,INC,JMP,WSAVE,WSAVE(2*N+1))
      RETURN
      END
      SUBROUTINE CFFTB1 (CR,CI,WR,WI,M,N,INC,JMP,WA,IFAC)
      INTEGER INC,JMP,M,N,IFAC(15)
      REAL CR(1+INC*(N-1)+JMP*(M-1)),CI(1+INC*(N-1)+JMP*(M-1))
      REAL WR(1+INC*(N-1)+JMP*(M-1)),WI(1+INC*(N-1)+JMP*(M-1))
      REAL WA(2*N)
      INTEGER NF,NA,L1,K1,IDO,L2,IDOT,IDL1,IP
      INTEGER IW,IX2,IX3,IX4,IX5,IX6,IX7
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDOT = IDO+IDO
         IDL1 = IDOT*L1
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IX4 = IX3+IDOT
         IX5 = IX4+IDOT
         IX6 = IX5+IDOT
         IX7 = IX6+IDOT
         IF (IP.GT.9.OR.IP.EQ.7) THEN
           WRITE(6,*) 'FACTOR',IP,'NOT IMPLEMENTED'
           STOP
         ENDIF
         IF(NA .EQ. 0) THEN
           IF (IP .EQ. 4) CALL PASSB4 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3))
           IF (IP .EQ. 6) CALL PASSB6 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5))
           IF (IP .EQ. 5) CALL PASSB5 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4))
           IF (IP .EQ. 8) CALL PASSB8 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &         WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5),WA(IX6),WA(IX7))
           IF (IP .EQ. 3) CALL PASSB3 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2))
           IF (IP .EQ. 2) CALL PASSB2 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW))
         ELSE
           IF (IP .EQ. 4) CALL PASSB4 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3))
           IF (IP .EQ. 6) CALL PASSB6 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5))
           IF (IP .EQ. 5) CALL PASSB5 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4))
           IF (IP .EQ. 8) CALL PASSB8 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &         WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5),WA(IX6),WA(IX7))
           IF (IP .EQ. 3) CALL PASSB3 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2))
           IF (IP .EQ. 2) CALL PASSB2 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW))
         ENDIF
         NA=1-NA
         L1 = L2
         IW = IW+(IP-1)*IDOT
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=0,N-1
      DO 117 J=0,M-1
         CR(1+INC*I+JMP*J) = WR(1+INC*I+JMP*J)
         CI(1+INC*I+JMP*J) = WI(1+INC*I+JMP*J)
  117 CONTINUE
      RETURN
      END

      SUBROUTINE PASSB2 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR2,TI2
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*2*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          CHR(IU,1) = CCR(II,1)+CCR(II,2)
          CHR(IU,2) = CCR(II,1)-CCR(II,2)
          CHI(IU,1) = CCI(II,1)+CCI(II,2)
          CHI(IU,2) = CCI(II,1)-CCI(II,2)
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*2*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          CHR(IU,1) = CCR(II,1)+CCR(II,2)
          TR2 = CCR(II,1)-CCR(II,2)
          CHI(IU,1) = CCI(II,1)+CCI(II,2)
          TI2 = CCI(II,1)-CCI(II,2)
          CHI(IU,2) = WA1(2*I-1)*TI2+WA1(2*I)*TR2
          CHR(IU,2) = WA1(2*I-1)*TR2-WA1(2*I)*TI2
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSB3 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1,WA2)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TAUR,TAUI
      REAL TR2,TI2,CR2,CI2,CR3,CI3,DR2,DI2,DR3,DI3
      DATA TAUR,TAUI /-.5,.866025403784439/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*3*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TR2 = CCR(II,2)+CCR(II,3)
          CR2 = CCR(II,1)+TAUR*TR2
          CHR(IU,1) = CCR(II,1)+TR2
          TI2 = CCI(II,2)+CCI(II,3)
          CI2 = CCI(II,1)+TAUR*TI2
          CHI(IU,1) = CCI(II,1)+TI2
          CR3 = TAUI*(CCR(II,2)-CCR(II,3))
          CI3 = TAUI*(CCI(II,2)-CCI(II,3))
          CHR(IU,2) = CR2-CI3
          CHR(IU,3) = CR2+CI3
          CHI(IU,2) = CI2+CR3
          CHI(IU,3) = CI2-CR3
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*3*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR2 = CCR(II,2)+CCR(II,3)
          CR2 = CCR(II,1)+TAUR*TR2
          CHR(IU,1) = CCR(II,1)+TR2
          TI2 = CCI(II,2)+CCI(II,3)
          CI2 = CCI(II,1)+TAUR*TI2
          CHI(IU,1) = CCI(II,1)+TI2
          CR3 = TAUI*(CCR(II,2)-CCR(II,3))
          CI3 = TAUI*(CCI(II,2)-CCI(II,3))
          DR2 = CR2-CI3
          DR3 = CR2+CI3
          DI2 = CI2+CR3
          DI3 = CI2-CR3
          CHI(IU,2) = WA1(2*I-1)*DI2+WA1(2*I)*DR2
          CHR(IU,2) = WA1(2*I-1)*DR2-WA1(2*I)*DI2
          CHI(IU,3) = WA2(2*I-1)*DI3+WA2(2*I)*DR3
          CHR(IU,3) = WA2(2*I-1)*DR3-WA2(2*I)*DI3
  103   CONTINUE
      ENDIF
      RETURN
      END


      SUBROUTINE PASSB4 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1,WA2,WA3)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR1,TI1,TR2,TI2,TR3,TI3,TR4,TI4,CR3,CI3
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*4*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TI1 = CCI(II,1)-CCI(II,3)
          TI2 = CCI(II,1)+CCI(II,3)
          TI3 = CCI(II,2)+CCI(II,4)
          TR4 = CCI(II,4)-CCI(II,2)
          CHI(IU,1) = TI2+TI3
          CHI(IU,3) = TI2-TI3
          CHR(IU,2) = CCR(II,1)-CCR(II,3)+TR4
          CHR(IU,4) = CCR(II,1)-CCR(II,3)-TR4
C          TR1 = CCR(II,1)-CCR(II,3)
C          TR2 = CCR(II,1)+CCR(II,3)
C          TI4 = CCR(II,2)-CCR(II,4)
C          TR3 = CCR(II,2)+CCR(II,4)
          CHI(IU,2) = TI1+(CCR(II,2)-CCR(II,4))
          CHI(IU,4) = TI1-(CCR(II,2)-CCR(II,4))
          CHR(IU,1) = CCR(II,1)+CCR(II,3)+(CCR(II,2)+CCR(II,4))
          CHR(IU,3) = CCR(II,1)+CCR(II,3)-(CCR(II,2)+CCR(II,4))
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*4*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR1 = CCR(II,1)-CCR(II,3)
          TR2 = CCR(II,1)+CCR(II,3)
          TR3 = CCR(II,2)+CCR(II,4)
          CR3 = TR2-TR3
          TI4 = CCR(II,2)-CCR(II,4)
          CHR(IU,1) = TR2+TR3
          TI1 = CCI(II,1)-CCI(II,3)
          TI2 = CCI(II,1)+CCI(II,3)
          TI3 = CCI(II,2)+CCI(II,4)
          TR4 = CCI(II,4)-CCI(II,2)
          CHI(IU,1) = TI2+TI3
          CI3 = TI2-TI3
          CHR(IU,3) = WA2(2*I-1)*CR3-WA2(2*I)*CI3
          CHI(IU,3) = WA2(2*I-1)*CI3+WA2(2*I)*CR3
C          CR2 = TR1+TR4
C          CR4 = TR1-TR4
C          CI2 = TI1+TI4
C          CI4 = TI1-TI4
          CHR(IU,2) = WA1(2*I-1)*(TR1+TR4)-WA1(2*I)*(TI1+TI4)
          CHI(IU,2) = WA1(2*I-1)*(TI1+TI4)+WA1(2*I)*(TR1+TR4)
          CHR(IU,4) = WA3(2*I-1)*(TR1-TR4)-WA3(2*I)*(TI1-TI4)
          CHI(IU,4) = WA3(2*I-1)*(TI1-TI4)+WA3(2*I)*(TR1-TR4)
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSB5(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR11,TI11,TR12,TI12
      REAL TR2,TI2,TR3,TI3,TR4,TI4,TR5,TI5,CR2,CI2,CR3,CI3,CR4,CI4
      REAL CR5,CI5
      DATA TR11,TI11,TR12,TI12 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*5*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TI5 = CCI(II,2)-CCI(II,5)
          TI2 = CCI(II,2)+CCI(II,5)
          TI4 = CCI(II,3)-CCI(II,4)
          TI3 = CCI(II,3)+CCI(II,4)
          CHI(IU,1) = CCI(II,1)+TI2+TI3
          TR5 = CCR(II,2)-CCR(II,5)
          TR2 = CCR(II,2)+CCR(II,5)
          TR4 = CCR(II,3)-CCR(II,4)
          TR3 = CCR(II,3)+CCR(II,4)
          CHR(IU,1) = CCR(II,1)+TR2+TR3
          CR2 = CCR(II,1)+TR11*TR2+TR12*TR3
          CR3 = CCR(II,1)+TR12*TR2+TR11*TR3
          CI2 = CCI(II,1)+TR11*TI2+TR12*TI3
          CI3 = CCI(II,1)+TR12*TI2+TR11*TI3
          CR5 = TI11*TR5+TI12*TR4
          CR4 = TI12*TR5-TI11*TR4
          CI5 = TI11*TI5+TI12*TI4
          CI4 = TI12*TI5-TI11*TI4
          CHR(IU,2) = CR2-CI5
          CHR(IU,5) = CR2+CI5
          CHI(IU,2) = CI2+CR5
          CHI(IU,5) = CI2-CR5
          CHR(IU,3) = CR3-CI4
          CHR(IU,4) = CR3+CI4
          CHI(IU,3) = CI3+CR4
          CHI(IU,4) = CI3-CR4
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*5*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TI5 = CCI(II,2)-CCI(II,5)
          TI2 = CCI(II,2)+CCI(II,5)
          TI4 = CCI(II,3)-CCI(II,4)
          TI3 = CCI(II,3)+CCI(II,4)
          TR5 = CCR(II,2)-CCR(II,5)
          TR2 = CCR(II,2)+CCR(II,5)
          TR4 = CCR(II,3)-CCR(II,4)
          TR3 = CCR(II,3)+CCR(II,4)
          CHR(IU,1) = CCR(II,1)+TR2+TR3
          CHI(IU,1) = CCI(II,1)+TI2+TI3
          CR2 = CCR(II,1)+TR11*TR2+TR12*TR3
          CR3 = CCR(II,1)+TR12*TR2+TR11*TR3
          CI2 = CCI(II,1)+TR11*TI2+TR12*TI3
          CI3 = CCI(II,1)+TR12*TI2+TR11*TI3
          CR5 = TI11*TR5+TI12*TR4
          CR4 = TI12*TR5-TI11*TR4
          CI5 = TI11*TI5+TI12*TI4
          CI4 = TI12*TI5-TI11*TI4
C          DR3 = CR3-CI4
C          DR4 = CR3+CI4
C          DI3 = CI3+CR4
C          DI4 = CI3-CR4
          CHR(IU,3) = WA2(2*I-1)*(CR3-CI4)-WA2(2*I)*(CI3+CR4)
          CHI(IU,3) = WA2(2*I-1)*(CI3+CR4)+WA2(2*I)*(CR3-CI4)
          CHR(IU,4) = WA3(2*I-1)*(CR3+CI4)-WA3(2*I)*(CI3-CR4)
          CHI(IU,4) = WA3(2*I-1)*(CI3-CR4)+WA3(2*I)*(CR3+CI4)
C          DR5 = CR2+CI5
C          DR2 = CR2-CI5
C          DI5 = CI2-CR5
C          DI2 = CI2+CR5
          CHR(IU,2) = WA1(2*I-1)*(CR2-CI5)-WA1(2*I)*(CI2+CR5)
          CHI(IU,2) = WA1(2*I-1)*(CI2+CR5)+WA1(2*I)*(CR2-CI5)
          CHR(IU,5) = WA4(2*I-1)*(CR2+CI5)-WA4(2*I)*(CI2-CR5)
          CHI(IU,5) = WA4(2*I-1)*(CI2-CR5)+WA4(2*I)*(CR2+CI5)
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSB6(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4,WA5)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO),WA5(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TAUR,TAUI
      REAL TR2,TI2,TR5,TI5
      REAL CR2,CI2,CR3,CI3,CR5,CI5,CR6,CI6
      REAL DR1,DI1,DR2,DI2,DR3,DI3,DR4,DI4,DR5,DI5,DR6,DI6
      REAL ER2,EI2,ER3,EI3,ER4,EI4,ER5,EI5,ER6,EI6
      DATA TAUR,TAUI /-.5,.866025403784439/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*6*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TR2 = CCR(II,3)+CCR(II,5)
          CR3 = TAUI*(CCR(II,3)-CCR(II,5))
          CR2 = CCR(II,1)+TAUR*TR2
          DR1 = CCR(II,1)+TR2
          TI2 = CCI(II,3)+CCI(II,5)
          CI3 = TAUI*(CCI(II,3)-CCI(II,5))
          CI2 = CCI(II,1)+TAUR*TI2
          DI1 = CCI(II,1)+TI2
C          DR3 = CR2-CI3
C          DR5 = CR2+CI3
          TR5 = CCR(II,6)+CCR(II,2)
          CR6 = TAUI*(CCR(II,6)-CCR(II,2))
          CR5 = CCR(II,4)+TAUR*TR5
          DR2 = CCR(II,4)+TR5
          TI5 = CCI(II,6)+CCI(II,2)
          CI6 = TAUI*(CCI(II,6)-CCI(II,2))
          CI5 = CCI(II,4)+TAUR*TI5
          DI2 = CCI(II,4)+TI5
          CHI(IU,1) = DI1+DI2
          CHI(IU,4) = DI1-DI2
          CHR(IU,1) = DR1+DR2
          CHR(IU,4) = DR1-DR2
C          DR4 = CR5-CI6
C          DR6 = CR5+CI6
C          DI3 = CI2+CR3
C          DI5 = CI2-CR3
C          DI4 = CI5+CR6
C          DI6 = CI5-CR6
          CHI(IU,5) = CI2+CR3+(CI5+CR6)
          CHI(IU,2) = CI2+CR3-(CI5+CR6)
          CHI(IU,3) = CI2-CR3+(CI5-CR6)
          CHI(IU,6) = CI2-CR3-(CI5-CR6)
          CHR(IU,5) = CR2-CI3+(CR5-CI6)
          CHR(IU,2) = CR2-CI3-(CR5-CI6)
          CHR(IU,3) = CR2+CI3+(CR5+CI6)
          CHR(IU,6) = CR2+CI3-(CR5+CI6)
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*6*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR2 = CCR(II,3)+CCR(II,5)
          CR3 = TAUI*(CCR(II,3)-CCR(II,5))
          CR2 = CCR(II,1)+TAUR*TR2
          DR1 = CCR(II,1)+TR2
          TI2 = CCI(II,3)+CCI(II,5)
          CI3 = TAUI*(CCI(II,3)-CCI(II,5))
          CI2 = CCI(II,1)+TAUR*TI2
          DI1 = CCI(II,1)+TI2
          DR3 = CR2-CI3
          DR5 = CR2+CI3
          DI3 = CI2+CR3
          DI5 = CI2-CR3
          TR5 = CCR(II,6)+CCR(II,2)
          CR6 = TAUI*(CCR(II,6)-CCR(II,2))
          CR5 = CCR(II,4)+TAUR*TR5
          DR2 = CCR(II,4)+TR5
          TI5 = CCI(II,6)+CCI(II,2)
          CI6 = TAUI*(CCI(II,6)-CCI(II,2))
          CI5 = CCI(II,4)+TAUR*TI5
          DI2 = CCI(II,4)+TI5
          CHR(IU,1) = DR1+DR2
          ER4 = DR1-DR2
          CHI(IU,1) = DI1+DI2
          EI4 = DI1-DI2
          DR4 = CR5-CI6
          DR6 = CR5+CI6
          DI4 = CI5+CR6
          DI6 = CI5-CR6
          CHR(IU,4) = WA3(2*I-1)*ER4-WA3(2*I)*EI4
          CHI(IU,4) = WA3(2*I-1)*EI4+WA3(2*I)*ER4
          ER5 = DR3+DR4
          ER2 = DR3-DR4
          EI5 = DI3+DI4
          EI2 = DI3-DI4
          CHR(IU,2) = WA1(2*I-1)*ER2-WA1(2*I)*EI2
          CHI(IU,2) = WA1(2*I-1)*EI2+WA1(2*I)*ER2
          CHR(IU,5) = WA4(2*I-1)*ER5-WA4(2*I)*EI5
          CHI(IU,5) = WA4(2*I-1)*EI5+WA4(2*I)*ER5
          ER3 = DR5+DR6
          ER6 = DR5-DR6
          EI3 = DI5+DI6
          EI6 = DI5-DI6
          CHR(IU,3) = WA2(2*I-1)*ER3-WA2(2*I)*EI3
          CHI(IU,3) = WA2(2*I-1)*EI3+WA2(2*I)*ER3
          CHR(IU,6) = WA5(2*I-1)*ER6-WA5(2*I)*EI6
          CHI(IU,6) = WA5(2*I-1)*EI6+WA5(2*I)*ER6
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSB8(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4,WA5,WA6,WA7)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO),WA5(2*IDO)
      REAL WA6(2*IDO),WA7(2*IDO)
      INTEGER I,J,K,II,IU
      REAL W
      REAL TR1,TI1,TR2,TI2,TR3,TI3,TR4,TI4
      REAL TR5,TI5,TR6,TI6,TR7,TI7,TR8,TI8
      REAL SR1,SI1,SR2,SI2,SR3,SI3,SR4,SI4
      REAL SR5,SI5,SR6,SI6,SR7,SI7,SR8,SI8
      REAL QR1,QI1,QR2,QI2,CR2,CI2,CR3,CI3,CR4,CI4
      REAL CR5,CI5,CR6,CI6,CR7,CI7,CR8,CI8
      DATA W/.7071067811865476/    
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*8*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          SR1 = CCR(II,1)+CCR(II,5)
          SR2 = CCR(II,1)-CCR(II,5)
          SR3 = CCR(II,2)+CCR(II,6)
          SR4 = CCR(II,2)-CCR(II,6)
          SR5 = CCR(II,3)+CCR(II,7)
          SR6 = CCR(II,3)-CCR(II,7)
          SR7 = CCR(II,4)+CCR(II,8)
          SR8 = CCR(II,4)-CCR(II,8)
          TR1 = SR1+SR5
          TR2 = SR1-SR5
          TR3 = SR3+SR7
          TR4 = SR3-SR7
          CHR(IU,1) = TR1+TR3 
          CHR(IU,5) = TR1-TR3
          SI1 = CCI(II,1)+CCI(II,5)
          SI2 = CCI(II,1)-CCI(II,5)
          SI3 = CCI(II,2)+CCI(II,6)
          SI4 = CCI(II,2)-CCI(II,6)
          SI5 = CCI(II,3)+CCI(II,7)
          SI6 = CCI(II,3)-CCI(II,7)
          SI7 = CCI(II,4)+CCI(II,8)
          SI8 = CCI(II,4)-CCI(II,8)
          TI1 = SI1+SI5
          TI2 = SI1-SI5
          TI3 = SI3+SI7
          TI4 = SI3-SI7
          CHI(IU,1) = TI1+TI3 
          CHI(IU,5) = TI1-TI3
          CHR(IU,3) = TR2-TI4
          CHR(IU,7) = TR2+TI4
          CHI(IU,3) = TI2+TR4
          CHI(IU,7) = TI2-TR4
          TR5 = SR2-SI6
          TR6 = SR2+SI6
          TR7 = W*(SR4-SI4)
          TI7 = W*(SI4+SR4)
          TR8 = W*(SR8-SI8)
          TI8 = W*(SI8+SR8)
          TI5 = SI2+SR6
          TI6 = SI2-SR6
          QI1 = TI7+TR8
          QR2 = TR8-TI7
          QR1 = TR7-TI8
          QI2 = TI8+TR7
          CHR(IU,2) = TR5+QR1
          CHR(IU,6) = TR5-QR1
          CHI(IU,2) = TI5+QI1
          CHI(IU,6) = TI5-QI1
          CHR(IU,4) = TR6+QR2
          CHR(IU,8) = TR6-QR2
          CHI(IU,4) = TI6+QI2
          CHI(IU,8) = TI6-QI2
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*8*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          SR1 = CCR(II,1)+CCR(II,5)
          SR2 = CCR(II,1)-CCR(II,5)
          SR3 = CCR(II,2)+CCR(II,6)
          SR4 = CCR(II,2)-CCR(II,6)
          SR5 = CCR(II,3)+CCR(II,7)
          SR6 = CCR(II,3)-CCR(II,7)
          SR7 = CCR(II,4)+CCR(II,8)
          SR8 = CCR(II,4)-CCR(II,8)
          TR1 = SR1+SR5
          TR2 = SR1-SR5
          TR3 = SR3+SR7
          TR4 = SR3-SR7
          CHR(IU,1) = TR1+TR3 
          CR5 = TR1-TR3
          SI1 = CCI(II,1)+CCI(II,5)
          SI2 = CCI(II,1)-CCI(II,5)
          SI3 = CCI(II,2)+CCI(II,6)
          SI4 = CCI(II,2)-CCI(II,6)
          SI5 = CCI(II,3)+CCI(II,7)
          SI6 = CCI(II,3)-CCI(II,7)
          SI7 = CCI(II,4)+CCI(II,8)
          SI8 = CCI(II,4)-CCI(II,8)
          TI1 = SI1+SI5
          TI2 = SI1-SI5
          TI3 = SI3+SI7
          TI4 = SI3-SI7
          CHI(IU,1) = TI1+TI3 
          CI5 = TI1-TI3
          CHR(IU,5) = WA4(2*I-1)*CR5-WA4(2*I)*CI5
          CHI(IU,5) = WA4(2*I-1)*CI5+WA4(2*I)*CR5
          CR3 = TR2-TI4
          CR7 = TR2+TI4
          CI3 = TI2+TR4
          CI7 = TI2-TR4
          CHR(IU,3) = WA2(2*I-1)*CR3-WA2(2*I)*CI3
          CHI(IU,3) = WA2(2*I-1)*CI3+WA2(2*I)*CR3
          CHR(IU,7) = WA6(2*I-1)*CR7-WA6(2*I)*CI7
          CHI(IU,7) = WA6(2*I-1)*CI7+WA6(2*I)*CR7
          TR5 = SR2-SI6
          TR6 = SR2+SI6
          TR7 = W*(SR4-SI4)
          TI7 = W*(SI4+SR4)
          TR8 = W*(SR8-SI8)
          TI8 = W*(SI8+SR8)
          TI5 = SI2+SR6
          TI6 = SI2-SR6
          QI1 = TI7+TR8
          QR2 = TR8-TI7
          QR1 = TR7-TI8
          QI2 = TI8+TR7
          CR2 = TR5+QR1
          CR6 = TR5-QR1
          CI2 = TI5+QI1
          CI6 = TI5-QI1
          CHR(IU,2) = WA1(2*I-1)*CR2-WA1(2*I)*CI2
          CHI(IU,2) = WA1(2*I-1)*CI2+WA1(2*I)*CR2
          CHR(IU,6) = WA5(2*I-1)*CR6-WA5(2*I)*CI6
          CHI(IU,6) = WA5(2*I-1)*CI6+WA5(2*I)*CR6
          CR4 = TR6+QR2
          CR8 = TR6-QR2
          CI4 = TI6+QI2
          CI8 = TI6-QI2
          CHR(IU,4) = WA3(2*I-1)*CR4-WA3(2*I)*CI4
          CHI(IU,4) = WA3(2*I-1)*CI4+WA3(2*I)*CR4
          CHR(IU,8) = WA7(2*I-1)*CR8-WA7(2*I)*CI8
          CHI(IU,8) = WA7(2*I-1)*CI8+WA7(2*I)*CR8
  103   CONTINUE
      ENDIF
      RETURN
      END




      SUBROUTINE VCFFTF (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N
      REAL CR(1+INC*(N-1)+JMP*(M-1)),CI(1+INC*(N-1)+JMP*(M-1))
      REAL WR(1+INC*(N-1)+JMP*(M-1)),WI(1+INC*(N-1)+JMP*(M-1))
      REAL WSAVE(15+2*N)
      IF (N .EQ. 1) RETURN
      CALL CFFTF1 (CR,CI,WR,WI,M,N,INC,JMP,WSAVE,WSAVE(2*N+1))
      RETURN
      END
      SUBROUTINE CFFTF1 (CR,CI,WR,WI,M,N,INC,JMP,WA,IFAC)
      INTEGER INC,JMP,M,N,IFAC(15)
      REAL CR(1+INC*(N-1)+JMP*(M-1)),CI(1+INC*(N-1)+JMP*(M-1))
      REAL WR(1+INC*(N-1)+JMP*(M-1)),WI(1+INC*(N-1)+JMP*(M-1))
      REAL WA(2*N)
      INTEGER NF,NA,L1,K1,IDO,L2,IDOT,IDL1,IP
      INTEGER IW,IX2,IX3,IX4,IX5,IX6,IX7
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDOT = IDO+IDO
         IDL1 = IDOT*L1
         IX2 = IW+IDOT
         IX3 = IX2+IDOT
         IX4 = IX3+IDOT
         IX5 = IX4+IDOT
         IX6 = IX5+IDOT
         IX7 = IX6+IDOT
         IF (IP.GT.9.OR.IP.EQ.7) THEN
           WRITE(6,*) 'FACTOR',IP,'NOT IMPLEMENTED'
           STOP
         ENDIF
         IF(NA .EQ. 0) THEN
           IF (IP .EQ. 4) CALL PASSF4 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3))
           IF (IP .EQ. 6) CALL PASSF6 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5))
           IF (IP .EQ. 5) CALL PASSF5 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4))
           IF (IP .EQ. 8) CALL PASSF8 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &         WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5),WA(IX6),WA(IX7))
           IF (IP .EQ. 3) CALL PASSF3 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2))
           IF (IP .EQ. 2) CALL PASSF2 (CR,CI,WR,WI,INC,JMP,M,IDO,L1,
     &                    WA(IW))
         ELSE
           IF (IP .EQ. 4) CALL PASSF4 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3))
           IF (IP .EQ. 6) CALL PASSF6 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5))
           IF (IP .EQ. 5) CALL PASSF5 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2),WA(IX3),WA(IX4))
           IF (IP .EQ. 8) CALL PASSF8 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &         WA(IW),WA(IX2),WA(IX3),WA(IX4),WA(IX5),WA(IX6),WA(IX7))
           IF (IP .EQ. 3) CALL PASSF3 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW),WA(IX2))
           IF (IP .EQ. 2) CALL PASSF2 (WR,WI,CR,CI,INC,JMP,M,IDO,L1,
     &                    WA(IW))
         ENDIF
         NA=1-NA
         L1 = L2
         IW = IW+(IP-1)*IDOT
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=0,N-1
      DO 117 J=0,M-1
         CR(1+INC*I+JMP*J) = WR(1+INC*I+JMP*J)
         CI(1+INC*I+JMP*J) = WI(1+INC*I+JMP*J)
  117 CONTINUE
      RETURN
      END

      SUBROUTINE PASSF2 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR2,TI2
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*2*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          CHR(IU,1) = CCR(II,1)+CCR(II,2)
          CHR(IU,2) = CCR(II,1)-CCR(II,2)
          CHI(IU,1) = CCI(II,1)+CCI(II,2)
          CHI(IU,2) = CCI(II,1)-CCI(II,2)
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*2*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          CHR(IU,1) = CCR(II,1)+CCR(II,2)
          TR2 = CCR(II,1)-CCR(II,2)
          CHI(IU,1) = CCI(II,1)+CCI(II,2)
          TI2 = CCI(II,1)-CCI(II,2)
          CHI(IU,2) = WA1(2*I-1)*TI2-WA1(2*I)*TR2
          CHR(IU,2) = WA1(2*I-1)*TR2+WA1(2*I)*TI2
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSF3 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1,WA2)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TAUR,TAUI
      REAL TR2,TI2,CR2,CI2,CR3,CI3,DR2,DI2,DR3,DI3
      DATA TAUR,TAUI /-.5,-.866025403784439/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*3*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TR2 = CCR(II,2)+CCR(II,3)
          CR2 = CCR(II,1)+TAUR*TR2
          CHR(IU,1) = CCR(II,1)+TR2
          TI2 = CCI(II,2)+CCI(II,3)
          CI2 = CCI(II,1)+TAUR*TI2
          CHI(IU,1) = CCI(II,1)+TI2
          CR3 = TAUI*(CCR(II,2)-CCR(II,3))
          CI3 = TAUI*(CCI(II,2)-CCI(II,3))
          CHR(IU,2) = CR2-CI3
          CHR(IU,3) = CR2+CI3
          CHI(IU,2) = CI2+CR3
          CHI(IU,3) = CI2-CR3
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*3*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR2 = CCR(II,2)+CCR(II,3)
          CR2 = CCR(II,1)+TAUR*TR2
          CHR(IU,1) = CCR(II,1)+TR2
          TI2 = CCI(II,2)+CCI(II,3)
          CI2 = CCI(II,1)+TAUR*TI2
          CHI(IU,1) = CCI(II,1)+TI2
          CR3 = TAUI*(CCR(II,2)-CCR(II,3))
          CI3 = TAUI*(CCI(II,2)-CCI(II,3))
          DR2 = CR2-CI3
          DR3 = CR2+CI3
          DI2 = CI2+CR3
          DI3 = CI2-CR3
          CHI(IU,2) = WA1(2*I-1)*DI2-WA1(2*I)*DR2
          CHR(IU,2) = WA1(2*I-1)*DR2+WA1(2*I)*DI2
          CHI(IU,3) = WA2(2*I-1)*DI3-WA2(2*I)*DR3
          CHR(IU,3) = WA2(2*I-1)*DR3+WA2(2*I)*DI3
  103   CONTINUE
      ENDIF
      RETURN
      END


      SUBROUTINE PASSF4 (CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,WA1,WA2,WA3)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR1,TI1,TR2,TI2,TR3,TI3,TR4,TI4,CR3,CI3
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*4*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TI1 = CCI(II,1)-CCI(II,3)
          TI2 = CCI(II,1)+CCI(II,3)
          TI3 = CCI(II,2)+CCI(II,4)
          CHI(IU,1) = TI2+TI3
          CHI(IU,3) = TI2-TI3
          TR4 = CCI(II,2)-CCI(II,4)
          CHR(IU,2) = CCR(II,1)-CCR(II,3)+TR4
          CHR(IU,4) = CCR(II,1)-CCR(II,3)-TR4
C          TR1 = CCR(II,1)-CCR(II,3)
C          TR2 = CCR(II,1)+CCR(II,3)
C          TI4 = CCR(II,4)-CCR(II,2)
C          TR3 = CCR(II,2)+CCR(II,4)
          CHI(IU,2) = (CCI(II,1)-CCI(II,3))+(CCR(II,4)-CCR(II,2))
          CHI(IU,4) = (CCI(II,1)-CCI(II,3))-(CCR(II,4)-CCR(II,2))
          CHR(IU,1) = CCR(II,1)+CCR(II,3)+(CCR(II,2)+CCR(II,4))
          CHR(IU,3) = CCR(II,1)+CCR(II,3)-(CCR(II,2)+CCR(II,4))
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*4*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR1 = CCR(II,1)-CCR(II,3)
          TR2 = CCR(II,1)+CCR(II,3)
          TR3 = CCR(II,2)+CCR(II,4)
          CR3 = TR2-TR3
          TI4 = CCR(II,4)-CCR(II,2)
          CHR(IU,1) = TR2+TR3
          TI1 = CCI(II,1)-CCI(II,3)
          TI2 = CCI(II,1)+CCI(II,3)
          TI3 = CCI(II,2)+CCI(II,4)
          TR4 = CCI(II,2)-CCI(II,4)
          CHI(IU,1) = TI2+TI3
          CI3 = TI2-TI3
          CHR(IU,3) = WA2(2*I-1)*CR3+WA2(2*I)*CI3
          CHI(IU,3) = WA2(2*I-1)*CI3-WA2(2*I)*CR3
C          CR2 = TR1+TR4
C          CR4 = TR1-TR4
C          CI2 = TI1+TI4
C          CI4 = TI1-TI4
          CHR(IU,2) = WA1(2*I-1)*(TR1+TR4)+WA1(2*I)*(TI1+TI4)
          CHI(IU,2) = WA1(2*I-1)*(TI1+TI4)-WA1(2*I)*(TR1+TR4)
          CHR(IU,4) = WA3(2*I-1)*(TR1-TR4)+WA3(2*I)*(TI1-TI4)
          CHI(IU,4) = WA3(2*I-1)*(TI1-TI4)-WA3(2*I)*(TR1-TR4)
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSF5(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TR11,TI11,TR12,TI12
      REAL TR2,TI2,TR3,TI3,TR4,TI4,TR5,TI5,CR2,CI2,CR3,CI3,CR4,CI4
      REAL CR5,CI5
      DATA TR11,TI11,TR12,TI12 /.309016994374947,-.951056516295154,
     1-.809016994374947,-.587785252292473/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*5*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TI5 = CCI(II,2)-CCI(II,5)
          TI2 = CCI(II,2)+CCI(II,5)
          TI4 = CCI(II,3)-CCI(II,4)
          TI3 = CCI(II,3)+CCI(II,4)
          CHI(IU,1) = CCI(II,1)+TI2+TI3
          TR5 = CCR(II,2)-CCR(II,5)
          TR2 = CCR(II,2)+CCR(II,5)
          TR4 = CCR(II,3)-CCR(II,4)
          TR3 = CCR(II,3)+CCR(II,4)
          CHR(IU,1) = CCR(II,1)+TR2+TR3
          CR2 = CCR(II,1)+TR11*TR2+TR12*TR3
          CR3 = CCR(II,1)+TR12*TR2+TR11*TR3
          CI2 = CCI(II,1)+TR11*TI2+TR12*TI3
          CI3 = CCI(II,1)+TR12*TI2+TR11*TI3
          CR5 = TI11*TR5+TI12*TR4
          CR4 = TI12*TR5-TI11*TR4
          CI5 = TI11*TI5+TI12*TI4
          CI4 = TI12*TI5-TI11*TI4
          CHR(IU,2) = CR2-CI5
          CHR(IU,5) = CR2+CI5
          CHI(IU,2) = CI2+CR5
          CHI(IU,5) = CI2-CR5
          CHR(IU,3) = CR3-CI4
          CHR(IU,4) = CR3+CI4
          CHI(IU,3) = CI3+CR4
          CHI(IU,4) = CI3-CR4
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*5*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TI5 = CCI(II,2)-CCI(II,5)
          TI2 = CCI(II,2)+CCI(II,5)
          TI4 = CCI(II,3)-CCI(II,4)
          TI3 = CCI(II,3)+CCI(II,4)
          TR5 = CCR(II,2)-CCR(II,5)
          TR2 = CCR(II,2)+CCR(II,5)
          TR4 = CCR(II,3)-CCR(II,4)
          TR3 = CCR(II,3)+CCR(II,4)
          CHR(IU,1) = CCR(II,1)+TR2+TR3
          CHI(IU,1) = CCI(II,1)+TI2+TI3
          CR2 = CCR(II,1)+TR11*TR2+TR12*TR3
          CR3 = CCR(II,1)+TR12*TR2+TR11*TR3
          CI2 = CCI(II,1)+TR11*TI2+TR12*TI3
          CI3 = CCI(II,1)+TR12*TI2+TR11*TI3
          CR5 = TI11*TR5+TI12*TR4
          CR4 = TI12*TR5-TI11*TR4
          CI5 = TI11*TI5+TI12*TI4
          CI4 = TI12*TI5-TI11*TI4
C          DR3 = CR3-CI4
C          DR4 = CR3+CI4
C          DI3 = CI3+CR4
C          DI4 = CI3-CR4
          CHR(IU,3) = WA2(2*I-1)*(CR3-CI4)+WA2(2*I)*(CI3+CR4)
          CHI(IU,3) = WA2(2*I-1)*(CI3+CR4)-WA2(2*I)*(CR3-CI4)
          CHR(IU,4) = WA3(2*I-1)*(CR3+CI4)+WA3(2*I)*(CI3-CR4)
          CHI(IU,4) = WA3(2*I-1)*(CI3-CR4)-WA3(2*I)*(CR3+CI4)
C          DR5 = CR2+CI5
C          DR2 = CR2-CI5
C          DI5 = CI2-CR5
C          DI2 = CI2+CR5
          CHR(IU,2) = WA1(2*I-1)*(CR2-CI5)+WA1(2*I)*(CI2+CR5)
          CHI(IU,2) = WA1(2*I-1)*(CI2+CR5)-WA1(2*I)*(CR2-CI5)
          CHR(IU,5) = WA4(2*I-1)*(CR2+CI5)+WA4(2*I)*(CI2-CR5)
          CHI(IU,5) = WA4(2*I-1)*(CI2-CR5)-WA4(2*I)*(CR2+CI5)
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSF6(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4,WA5)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO),WA5(2*IDO)
      INTEGER I,J,K,II,IU
      REAL TAUR,TAUI
      REAL TR2,TI2,TR5,TI5
      REAL CR2,CI2,CR3,CI3,CR5,CI5,CR6,CI6
      REAL DR1,DI1,DR2,DI2,DR3,DI3,DR4,DI4,DR5,DI5,DR6,DI6
      REAL ER2,EI2,ER3,EI3,ER4,EI4,ER5,EI5,ER6,EI6
      DATA TAUR,TAUI /-.5,-.866025403784439/
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*6*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          TR2 = CCR(II,3)+CCR(II,5)
          CR3 = TAUI*(CCR(II,3)-CCR(II,5))
          CR2 = CCR(II,1)+TAUR*TR2
          DR1 = CCR(II,1)+TR2
          TI2 = CCI(II,3)+CCI(II,5)
          CI3 = TAUI*(CCI(II,3)-CCI(II,5))
          CI2 = CCI(II,1)+TAUR*TI2
          DI1 = CCI(II,1)+TI2
C          DR3 = CR2-CI3
C          DR5 = CR2+CI3
          TR5 = CCR(II,6)+CCR(II,2)
          CR6 = TAUI*(CCR(II,6)-CCR(II,2))
          CR5 = CCR(II,4)+TAUR*TR5
          DR2 = CCR(II,4)+TR5
          TI5 = CCI(II,6)+CCI(II,2)
          CI6 = TAUI*(CCI(II,6)-CCI(II,2))
          CI5 = CCI(II,4)+TAUR*TI5
          DI2 = CCI(II,4)+TI5
          CHI(IU,1) = DI1+DI2
          CHI(IU,4) = DI1-DI2
          CHR(IU,1) = DR1+DR2
          CHR(IU,4) = DR1-DR2
C          DR4 = CR5-CI6
C          DR6 = CR5+CI6
C          DI3 = CI2+CR3
C          DI5 = CI2-CR3
C          DI4 = CI5+CR6
C          DI6 = CI5-CR6
          CHI(IU,5) = CI2+CR3+(CI5+CR6)
          CHI(IU,2) = CI2+CR3-(CI5+CR6)
          CHI(IU,3) = CI2-CR3+(CI5-CR6)
          CHI(IU,6) = CI2-CR3-(CI5-CR6)
          CHR(IU,5) = CR2-CI3+(CR5-CI6)
          CHR(IU,2) = CR2-CI3-(CR5-CI6)
          CHR(IU,3) = CR2+CI3+(CR5+CI6)
          CHR(IU,6) = CR2+CI3-(CR5+CI6)
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*6*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          TR2 = CCR(II,3)+CCR(II,5)
          CR3 = TAUI*(CCR(II,3)-CCR(II,5))
          CR2 = CCR(II,1)+TAUR*TR2
          DR1 = CCR(II,1)+TR2
          TI2 = CCI(II,3)+CCI(II,5)
          CI3 = TAUI*(CCI(II,3)-CCI(II,5))
          CI2 = CCI(II,1)+TAUR*TI2
          DI1 = CCI(II,1)+TI2
          DR3 = CR2-CI3
          DR5 = CR2+CI3
          DI3 = CI2+CR3
          DI5 = CI2-CR3
          TR5 = CCR(II,6)+CCR(II,2)
          CR6 = TAUI*(CCR(II,6)-CCR(II,2))
          CR5 = CCR(II,4)+TAUR*TR5
          DR2 = CCR(II,4)+TR5
          TI5 = CCI(II,6)+CCI(II,2)
          CI6 = TAUI*(CCI(II,6)-CCI(II,2))
          CI5 = CCI(II,4)+TAUR*TI5
          DI2 = CCI(II,4)+TI5
          CHR(IU,1) = DR1+DR2
          ER4 = DR1-DR2
          CHI(IU,1) = DI1+DI2
          EI4 = DI1-DI2
          DR4 = CR5-CI6
          DR6 = CR5+CI6
          DI4 = CI5+CR6
          DI6 = CI5-CR6
          CHR(IU,4) = WA3(2*I-1)*ER4+WA3(2*I)*EI4
          CHI(IU,4) = WA3(2*I-1)*EI4-WA3(2*I)*ER4
          ER5 = DR3+DR4
          ER2 = DR3-DR4
          EI5 = DI3+DI4
          EI2 = DI3-DI4
          CHR(IU,2) = WA1(2*I-1)*ER2+WA1(2*I)*EI2
          CHI(IU,2) = WA1(2*I-1)*EI2-WA1(2*I)*ER2
          CHR(IU,5) = WA4(2*I-1)*ER5+WA4(2*I)*EI5
          CHI(IU,5) = WA4(2*I-1)*EI5-WA4(2*I)*ER5
          ER3 = DR5+DR6
          ER6 = DR5-DR6
          EI3 = DI5+DI6
          EI6 = DI5-DI6
          CHR(IU,3) = WA2(2*I-1)*ER3+WA2(2*I)*EI3
          CHI(IU,3) = WA2(2*I-1)*EI3-WA2(2*I)*ER3
          CHR(IU,6) = WA5(2*I-1)*ER6+WA5(2*I)*EI6
          CHI(IU,6) = WA5(2*I-1)*EI6-WA5(2*I)*ER6
  103   CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE PASSF8(CCR,CCI,CHR,CHI,INC,JMP,M,IDO,L1,
     & WA1,WA2,WA3,WA4,WA5,WA6,WA7)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,IDO,L1
      REAL CCR(INC*IDO,1),CCI(INC*IDO,1)
      REAL CHR(INC*IDO*L1,1),CHI(INC*IDO*L1,1)
      REAL WA1(2*IDO),WA2(2*IDO),WA3(2*IDO),WA4(2*IDO),WA5(2*IDO)
      REAL WA6(2*IDO),WA7(2*IDO)
      INTEGER I,J,K,II,IU
      REAL W
      REAL TR1,TI1,TR2,TI2,TR3,TI3,TR4,TI4
      REAL TR5,TI5,TR6,TI6,TR7,TI7,TR8,TI8
      REAL SR1,SI1,SR2,SI2,SR3,SI3,SR4,SI4
      REAL SR5,SI5,SR6,SI6,SR7,SI7,SR8,SI8
      REAL QR1,QI1,QR2,QI2,CR2,CI2,CR3,CI3,CR4,CI4
      REAL CR5,CI5,CR6,CI6,CR7,CI7,CR8,CI8
      DATA W/.7071067811865476/    
      IF (IDO .EQ. 1) THEN
        DO 101 K=1,L1
        DO 101 J=1,M
          II=1+JMP*(J-1)+INC*IDO*8*(K-1)
          IU=1+JMP*(J-1)+INC*IDO*(K-1)
          SR1 = CCR(II,1)+CCR(II,5)
          SR2 = CCR(II,1)-CCR(II,5)
          SR3 = CCR(II,2)+CCR(II,6)
          SR4 = CCR(II,2)-CCR(II,6)
          SR5 = CCR(II,3)+CCR(II,7)
          SR6 = CCR(II,3)-CCR(II,7)
          SR7 = CCR(II,4)+CCR(II,8)
          SR8 = CCR(II,4)-CCR(II,8)
          TR1 = SR1+SR5
          TR2 = SR1-SR5
          TR3 = SR3+SR7
          TR4 = SR3-SR7
          CHR(IU,1) = TR1+TR3 
          CHR(IU,5) = TR1-TR3
          SI1 = CCI(II,1)+CCI(II,5)
          SI2 = CCI(II,1)-CCI(II,5)
          SI3 = CCI(II,2)+CCI(II,6)
          SI4 = CCI(II,2)-CCI(II,6)
          SI5 = CCI(II,3)+CCI(II,7)
          SI6 = CCI(II,3)-CCI(II,7)
          SI7 = CCI(II,4)+CCI(II,8)
          SI8 = CCI(II,4)-CCI(II,8)
          TI1 = SI1+SI5
          TI2 = SI1-SI5
          TI3 = SI3+SI7
          TI4 = SI3-SI7
          CHI(IU,1) = TI1+TI3 
          CHI(IU,5) = TI1-TI3
          CHR(IU,3) = TR2+TI4
          CHR(IU,7) = TR2-TI4
          CHI(IU,3) = TI2-TR4
          CHI(IU,7) = TI2+TR4
          TR5 = SR2+SI6
          TR6 = SR2-SI6
          TR7 = W*(SR4+SI4)
          TI7 = W*(SI4-SR4)
          TR8 = W*(SR8+SI8)
          TI8 = W*(SI8-SR8)
          TI5 = SI2-SR6
          TI6 = SI2+SR6
          QI1 = TI7-TR8
          QR2 = TR8+TI7
          QR1 = TR7+TI8
          QI2 = TI8-TR7
          CHR(IU,2) = TR5+QR1
          CHR(IU,6) = TR5-QR1
          CHI(IU,2) = TI5+QI1
          CHI(IU,6) = TI5-QI1
          CHR(IU,4) = TR6+QR2
          CHR(IU,8) = TR6-QR2
          CHI(IU,4) = TI6+QI2
          CHI(IU,8) = TI6-QI2
  101   CONTINUE
      ELSE
        DO 103 K=1,L1
        DO 103 I=1,IDO
        DO 103 J=1,M
          II=1+JMP*(J-1)+INC*(IDO*8*(K-1)+(I-1))
          IU=1+JMP*(J-1)+INC*(IDO*(K-1)+(I-1))
          SR1 = CCR(II,1)+CCR(II,5)
          SR2 = CCR(II,1)-CCR(II,5)
          SR3 = CCR(II,2)+CCR(II,6)
          SR4 = CCR(II,2)-CCR(II,6)
          SR5 = CCR(II,3)+CCR(II,7)
          SR6 = CCR(II,3)-CCR(II,7)
          SR7 = CCR(II,4)+CCR(II,8)
          SR8 = CCR(II,4)-CCR(II,8)
          TR1 = SR1+SR5
          TR2 = SR1-SR5
          TR3 = SR3+SR7
          TR4 = SR3-SR7
          CHR(IU,1) = TR1+TR3 
          CR5 = TR1-TR3
          SI1 = CCI(II,1)+CCI(II,5)
          SI2 = CCI(II,1)-CCI(II,5)
          SI3 = CCI(II,2)+CCI(II,6)
          SI4 = CCI(II,2)-CCI(II,6)
          SI5 = CCI(II,3)+CCI(II,7)
          SI6 = CCI(II,3)-CCI(II,7)
          SI7 = CCI(II,4)+CCI(II,8)
          SI8 = CCI(II,4)-CCI(II,8)
          TI1 = SI1+SI5
          TI2 = SI1-SI5
          TI3 = SI3+SI7
          TI4 = SI3-SI7
          CHI(IU,1) = TI1+TI3 
          CI5 = TI1-TI3
          CHR(IU,5) = WA4(2*I-1)*CR5+WA4(2*I)*CI5
          CHI(IU,5) = WA4(2*I-1)*CI5-WA4(2*I)*CR5
          CR3 = TR2+TI4
          CR7 = TR2-TI4
          CI3 = TI2-TR4
          CI7 = TI2+TR4
          CHR(IU,3) = WA2(2*I-1)*CR3+WA2(2*I)*CI3
          CHI(IU,3) = WA2(2*I-1)*CI3-WA2(2*I)*CR3
          CHR(IU,7) = WA6(2*I-1)*CR7+WA6(2*I)*CI7
          CHI(IU,7) = WA6(2*I-1)*CI7-WA6(2*I)*CR7
          TR5 = SR2+SI6
          TR6 = SR2-SI6
          TR7 = W*(SR4+SI4)
          TI7 = W*(SI4-SR4)
          TR8 = W*(SR8+SI8)
          TI8 = W*(SI8-SR8)
          TI5 = SI2-SR6
          TI6 = SI2+SR6
          QI1 = TI7-TR8
          QR2 = TR8+TI7
          QR1 = TR7+TI8
          QI2 = TI8-TR7
          CR2 = TR5+QR1
          CR6 = TR5-QR1
          CI2 = TI5+QI1
          CI6 = TI5-QI1
          CHR(IU,2) = WA1(2*I-1)*CR2+WA1(2*I)*CI2
          CHI(IU,2) = WA1(2*I-1)*CI2-WA1(2*I)*CR2
          CHR(IU,6) = WA5(2*I-1)*CR6+WA5(2*I)*CI6
          CHI(IU,6) = WA5(2*I-1)*CI6-WA5(2*I)*CR6
          CR4 = TR6+QR2
          CR8 = TR6-QR2
          CI4 = TI6+QI2
          CI8 = TI6-QI2
          CHR(IU,4) = WA3(2*I-1)*CR4+WA3(2*I)*CI4
          CHI(IU,4) = WA3(2*I-1)*CI4-WA3(2*I)*CR4
          CHR(IU,8) = WA7(2*I-1)*CR8+WA7(2*I)*CI8
          CHI(IU,8) = WA7(2*I-1)*CI8-WA7(2*I)*CR8
  103   CONTINUE
      ENDIF
      RETURN
      END




      SUBROUTINE VCFFTI (N,WSAVE,IFAIL)
      DIMENSION       WSAVE(1)
      IFAILN=0
      IF (N .NE. 1) THEN
        IW1 = 1
        IW2 = IW1+N+N
        CALL CFFTI1 (N,WSAVE(IW1),WSAVE(IW2),IFAILN)
      ENDIF
      IF(IFAIL.EQ.0.AND.IFAILN.NE.0) THEN
        WRITE(*,*) 'VCFFTI-ERROR-CANNOT FACTOR',IFAILN
        STOP
      ENDIF
      IF(IFAIL.NE.0) IFAIL=IFAILN    
      RETURN
      END
      SUBROUTINE CFFTI1 (N,WA,IFAC,IFAIL)
      DIMENSION       WA(1),IFAC(1),NTRYH(6),NFAC(6)
      DATA NTRYH/2,3,4,5,6,8/
      IFAIL=0
      NL = N
      NF = 0
      NFAC(6)=0
C FIRST FACTOR N, SELECT LARGE FACTORS FIRST EXCEPT 8
      DO 101 J=5,1,-1
        NFAC(J)=0
        NTRY=NTRYH(J)
 102    IF (NL.EQ.NL/NTRY*NTRY) THEN
          NL=NL/NTRY
          NF=NF+1
          NFAC(J)=NFAC(J)+1
          GOTO 102
        ENDIF
 101  CONTINUE
      IF(NL.NE.1) THEN
        IFAIL=1
        RETURN
      ENDIF
C MAKE A SINGLE FACTOR 8 OUT OF A 4 AND A 2 IF NF BECOMES EVEN
C (SAVES THE OVERHEAD OF COPYING DATA AT LEAST)
      IF(NFAC(1).GE.1.AND.NFAC(3).GE.1.AND.NF/2*2.NE.NF) THEN
        NFAC(1)=NFAC(1)-1
        NFAC(3)=NFAC(3)-1
        NFAC(6)=NFAC(6)+1
        NF=NF-1
      ENDIF
C NOW INSERT THE FACTORS INTO IFAC BUT THE LARGEST FACTOR LAST
      NP=3
      DO 103 J=1,6
        DO 104 NP=NP,NP-1+NFAC(J)
          IFAC(NP)=NTRYH(J)
 104    CONTINUE
 103  CONTINUE
      IFAC(1) = N
      IFAC(2) = NF
C
      TPI = 6.28318530717959
      ARGH = TPI/FLOAT(N)
      I = 2
      L1 = 1
      DO 110 K1=1,NF
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IDOT = IDO+IDO+2
         IPM = IP-1
         DO 109 J=1,IPM
            I1 = I
            WA(I-1) = 1.
            WA(I) = 0.
            LD = LD+L1
            FI=0.
            ARGLD = FLOAT(LD)*ARGH
            DO 108 II=4,IDOT,2
               I = I+2
               FI=FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
CC            IF (IP .LE. 5) GO TO 109
CC            WA(I1-1) = WA(I-1)
CC            WA(I1) = WA(I)
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END


      SUBROUTINE VCFFTS (CR,CI,WR,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N
      REAL CR(1+INC*(N+1)+JMP*(M-1)),CI(1+INC*(N+1)+JMP*(M-1))
      REAL WR(1+INC*(N+1)+1+JMP*(M-1))
      REAL WSAVE(15+2*N)
      CALL VCOST(CR,WR,N,M,INC,JMP,WSAVE)
      CALL VCOST(CI,WR,N,M,INC,JMP,WSAVE)
      RETURN
      END

      SUBROUTINE VCFTAB (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N,IW1,IW2,NP1
      REAL CR(1+INC*N+JMP*(M-1)),CI(1+INC*N+JMP*(M-1))
      REAL WR(1+INC*N+JMP*(M-1)),WI(1+INC*N+JMP*(M-1))
      REAL WSAVE(15+2*N)
      NP1 = N+1
      IW1 = N/2+1
      IW2 = IW1+NP1
      CALL CFTAB1(CR,CI,WR,WI,N,M,INC,JMP,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

      SUBROUTINE CFTAB1(XR,XI,WR,WI,N,M,INC,JMP,WAS,WAR,IFAC)
      DIMENSION WAR(1),WAS(1),IFAC(1)
      REAL XR(INC,1),XI(INC,1),WR(INC,1),WI(INC,1)
      DATA SQRT3 /1.73205080756888/
      IF(N.EQ.1) THEN
        DO 200 J=1,M
          JJ=1+(J-1)*JMP
          T1 = 2.*XR(JJ,1)
          XR(JJ,1) = -2.*XI(JJ,1)
          XI(JJ,1) = T1
 200    CONTINUE
      ELSE
      NP1 = N+1
      NS2 = N/2
      DO 205 J=1,M
        JJ=1+(J-1)*JMP
        WR(JJ,1) = 0.
        WI(JJ,1) = 0.
 205  CONTINUE
      DO 104 K=1,NS2
        KC = NP1-K
CDIR$ IVDEP
        DO 202 J=1,M
          JJ=1+(J-1)*JMP
          T1 = XR(JJ,K)-XR(JJ,KC)
          T2 = WAS(K)*(XR(JJ,K)+XR(JJ,KC))
	  WR(JJ,K+1) = T1+T2
	  WR(JJ,KC+1) = T2-T1
          T1 = XI(JJ,K)-XI(JJ,KC)
          T2 = WAS(K)*(XI(JJ,K)+XI(JJ,KC))
	  WI(JJ,K+1) = T1+T2
	  WI(JJ,KC+1) = T2-T1
  202   CONTINUE
  104 CONTINUE
      DO 203 J=1,M
        JJ=1+(J-1)*JMP
        WR(JJ,NS2+2) = 4.*XR(JJ,NS2+1)
        WI(JJ,NS2+2) = 4.*XI(JJ,NS2+1)
 203  CONTINUE
      CALL RFFTF1 (WR,WR(1,2),XR,XR(1,2),NP1,M,2*INC,JMP,WAR,IFAC)
      CALL RFFTF1 (WI,WI(1,2),XI,XI(1,2),NP1,M,2*INC,JMP,WAR,IFAC)
CDIR$ IVDEP
      DO 204 J=1,M
        JJ=1+(J-1)*JMP
        XI(JJ,1) = .5*WR(JJ,1)
        XR(JJ,1) = -.5*WI(JJ,1)
        XI(JJ,N+1) = 0.
        XR(JJ,N+1) = 0.
 204  CONTINUE
      DO 105 I=3,N,2
CDIR$ IVDEP
      DO 105 J=1,M
         JJ=1+(J-1)*JMP
	 XI(JJ,I-1) = -WR(JJ,I+1)
	 XI(JJ,I) = XI(JJ,I-2)+WR(JJ,I)
	 XR(JJ,I-1) = WI(JJ,I+1)
	 XR(JJ,I) = XR(JJ,I-2)-WI(JJ,I)
  105 CONTINUE
      RETURN
      ENDIF
      END
      SUBROUTINE VCFTAF (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N,IW1,IW2,NP1
      REAL CR(1+INC*N+JMP*(M-1)),CI(1+INC*N+JMP*(M-1))
      REAL WR(1+INC*N+JMP*(M-1)),WI(1+INC*N+JMP*(M-1))
      REAL WSAVE(15+2*N)
      NP1 = N+1
      IW1 = N/2+1
      IW2 = IW1+NP1
      CALL CFTAF1(CR,CI,WR,WI,N,M,INC,JMP,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END

      SUBROUTINE CFTAF1(XR,XI,WR,WI,N,M,INC,JMP,WAS,WAR,IFAC)
      DIMENSION WAR(1),WAS(1),IFAC(1)
      REAL XR(INC,1),XI(INC,1),WR(INC,1),WI(INC,1)
      DATA SQRT3 /1.73205080756888/
      IF(N.EQ.1) THEN
        DO 200 J=1,M
          JJ=1+(J-1)*JMP
          T1 = -2.*XR(JJ,1)
          XR(JJ,1) = 2.*XI(JJ,1)
          XI(JJ,1) = T1
 200    CONTINUE
      ELSE
      NP1 = N+1
      NS2 = N/2
      DO 205 J=1,M
        JJ=1+(J-1)*JMP
        WR(JJ,1) = 0.
        WI(JJ,1) = 0.
 205  CONTINUE
      DO 104 K=1,NS2
        KC = NP1-K
CDIR$ IVDEP
        DO 202 J=1,M
          JJ=1+(J-1)*JMP
          T1 = XR(JJ,K)-XR(JJ,KC)
          T2 = WAS(K)*(XR(JJ,K)+XR(JJ,KC))
	  WR(JJ,K+1) = T1+T2
	  WR(JJ,KC+1) = T2-T1
          T1 = XI(JJ,K)-XI(JJ,KC)
          T2 = WAS(K)*(XI(JJ,K)+XI(JJ,KC))
	  WI(JJ,K+1) = T1+T2
	  WI(JJ,KC+1) = T2-T1
  202   CONTINUE
  104 CONTINUE
      DO 203 J=1,M
        JJ=1+(J-1)*JMP
        WR(JJ,NS2+2) = 4.*XR(JJ,NS2+1)
        WI(JJ,NS2+2) = 4.*XI(JJ,NS2+1)
 203  CONTINUE
      CALL RFFTF1 (WR,WR(1,2),XR,XR(1,2),NP1,M,2*INC,JMP,WAR,IFAC)
      CALL RFFTF1 (WI,WI(1,2),XI,XI(1,2),NP1,M,2*INC,JMP,WAR,IFAC)
CDIR$ IVDEP
      DO 204 J=1,M
        JJ=1+(J-1)*JMP
        XI(JJ,1) = -.5*WR(JJ,1)
        XR(JJ,1) = .5*WI(JJ,1)
        XI(JJ,N+1) = 0.
        XR(JJ,N+1) = 0.
 204  CONTINUE
      DO 105 I=3,N,2
CDIR$ IVDEP
      DO 105 J=1,M
         JJ=1+(J-1)*JMP
	 XI(JJ,I-1) = WR(JJ,I+1)
	 XI(JJ,I) = XI(JJ,I-2)-WR(JJ,I)
	 XR(JJ,I-1) = -WI(JJ,I+1)
	 XR(JJ,I) = XR(JJ,I-2)+WI(JJ,I)
  105 CONTINUE
      RETURN
      ENDIF
      END
      SUBROUTINE VCHBB (X,W,N,M,INC,JMP,WSAVE)
      REAL WSAVE(2*N+15),X(INC,1),W(INC,1)
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      IF (N.GT.1) THEN
        IF(N.EQ.3) THEN
          DO 101 J=1,M
            JJ=1+(J-1)*JMP
            X1P3 = X(JJ,1)+X(JJ,3)
            TX2 = X(JJ,2)
            X(JJ,2) = (X(JJ,1)-X(JJ,3))
            X(JJ,1) = (X1P3+TX2)
            X(JJ,3) = (X1P3-TX2)
 101        CONTINUE
        ELSE
CDIR$ IVDEP
          DO 102 J=1,M
            JJ=1+(J-1)*JMP
            W(JJ,1) = X(JJ,1)-X(JJ,N)
            X(JJ,1) = X(JJ,1)+X(JJ,N)
 102      CONTINUE
          DO 103 K=2,NS2
            KC = NP1-K
CDIR$ IVDEP
            DO 103 J=1,M
              JJ=1+(J-1)*JMP
              T1 = .5*(X(JJ,K)+X(JJ,KC))
              T2 = X(JJ,K)-X(JJ,KC)
              W(JJ,1) = W(JJ,1)+.5*WSAVE(KC)*T2
              T2 = .5*WSAVE(K)*T2
              X(JJ,K) = T1-T2
              X(JJ,KC) = T1+T2
 103      CONTINUE
          DO 104 J=1,M
            JJ=1+(J-1)*JMP
C            X(JJ,NS2+1) = 2.*X(JJ,NS2+1)
 104      CONTINUE
          CALL RFFTF1 (X,X(1,2),W,W(1,2),NM1,M,
     &      2*INC,JMP,WSAVE(N+1),WSAVE(N+N))
          DO 105 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,2) = W(JJ,1)
 105      CONTINUE
          DO 106 I=4,N,2
CDIR$ IVDEP
          DO 106 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,I) = X(JJ,I-2)-X(JJ,I)
 106      CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE VCHBF (X,W,N,M,INC,JMP,WSAVE)
      REAL WSAVE(2*N+15),X(INC,1),W(INC,1)
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      IF (N.GT.1) THEN
        IF(N.EQ.3) THEN
          DO 101 J=1,M
            JJ=1+(J-1)*JMP
            X1P3 = X(JJ,1)+X(JJ,3)
            TX2 = X(JJ,2)+X(JJ,2)
            X(JJ,2) = (X(JJ,1)-X(JJ,3))*.5
            X(JJ,1) = (X1P3+TX2)*.25
            X(JJ,3) = (X1P3-TX2)*.25
 101        CONTINUE
        ELSE
CDIR$ IVDEP
          DO 102 J=1,M
            JJ=1+(J-1)*JMP
            W(JJ,1) = (X(JJ,1)-X(JJ,N))*.5
            X(JJ,1) = (X(JJ,1)+X(JJ,N))*.5
 102      CONTINUE
          DO 103 K=2,NS2
            KC = NP1-K
CDIR$ IVDEP
            DO 103 J=1,M
              JJ=1+(J-1)*JMP
              T1 = .5*(X(JJ,K)+X(JJ,KC))
              T2 = X(JJ,K)-X(JJ,KC)
              W(JJ,1) = W(JJ,1)+.5*WSAVE(KC)*T2
              T2 = .5*WSAVE(K)*T2
              X(JJ,K) = T1-T2
              X(JJ,KC) = T1+T2
 103      CONTINUE
          CALL RFFTF1 (X,X(1,2),W,W(1,2),NM1,M,
     &      2*INC,JMP,WSAVE(N+1),WSAVE(N+N))
          DO 105 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,2) = W(JJ,1)
 105      CONTINUE
          DO 106 I=4,N,2
          DO 106 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,I) = X(JJ,I-2)-X(JJ,I)
 106      CONTINUE
CDIR$ IVDEP
          DO 107 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,1) = X(JJ,1)*.5
            X(JJ,N) = X(JJ,N)*.5
 107     CONTINUE
        ENDIF
      ENDIF
      RETURN
      END


      SUBROUTINE VCOST (X,W,N,M,INC,JMP,WSAVE)
      REAL WSAVE(2*N+15),X(INC,1),W(INC,1)
      NM1 = N-1
      NP1 = N+1
      NS2 = N/2
      IF (N.GT.1) THEN
        IF(N.EQ.3) THEN
          DO 101 J=1,M
            JJ=1+(J-1)*JMP
            X1P3 = X(JJ,1)+X(JJ,3)
            TX2 = X(JJ,2)+X(JJ,2)
            X(JJ,2) = X(JJ,1)-X(JJ,3)
            X(JJ,1) = X1P3+TX2
            X(JJ,3) = X1P3-TX2
 101        CONTINUE
        ELSE
CDIR$ IVDEP
          DO 102 J=1,M
            JJ=1+(J-1)*JMP
            W(JJ,1) = X(JJ,1)-X(JJ,N)
            X(JJ,1) = X(JJ,1)+X(JJ,N)
 102      CONTINUE
          DO 103 K=2,NS2
            KC = NP1-K
CDIR$ IVDEP
            DO 103 J=1,M
              JJ=1+(J-1)*JMP
              T1 = X(JJ,K)+X(JJ,KC)
              T2 = X(JJ,K)-X(JJ,KC)
              W(JJ,1) = W(JJ,1)+WSAVE(KC)*T2
              X(JJ,K) = T1-WSAVE(K)*T2
              X(JJ,KC) = T1+WSAVE(K)*T2
 103      CONTINUE
          DO 104 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,NS2+1) = 2.*X(JJ,NS2+1)
 104      CONTINUE
          CALL RFFTF1 (X,X(1,2),W,W(1,2),NM1,M,
     &      2*INC,JMP,WSAVE(N+1),WSAVE(N+N))
          DO 105 J=1,M
            JJ=1+(J-1)*JMP
C            W(JJ,2) = X(JJ,3)
            X(JJ,2) = W(JJ,1)
 105      CONTINUE
          DO 106 I=4,N,2
CDIR$ IVDEP
          DO 106 J=1,M
            JJ=1+(J-1)*JMP
            X(JJ,I) = X(JJ,I-2)-X(JJ,I)
 106      CONTINUE
          DO 107 J=1,M
            JJ=1+(J-1)*JMP
 107     CONTINUE
        ENDIF
      ENDIF
      RETURN
      END

      SUBROUTINE VCOSTI (N,WSAVE,IFAIL)
      DIMENSION       WSAVE(2*N+15)
      DATA PI /3.14159265358979/
      IFAILN=0
      IF (N .EQ. 2) IFAILN=1
      IF (N .GT. 3) THEN
        NM1 = N-1
        NP1 = N+1
        NS2 = N/2
        DT = PI/FLOAT(NM1)
        FK = 0.
        DO 101 K=2,NS2
          KC = NP1-K
          FK = FK+1.
          WSAVE(K) = 2.*SIN(FK*DT)
          WSAVE(KC) = 2.*COS(FK*DT)
  101   CONTINUE
        CALL RFFTI1 (NM1,WSAVE(N+1),WSAVE(N+N),IFAILN)
      ENDIF
      IF(IFAIL.EQ.0.AND.IFAILN.NE.0) THEN
          IF(IFAILN.EQ.1) THEN
            WRITE(*,*) 'VCOSTI-ERROR-N MUST BE ODD'
          ELSE
            WRITE(*,*) 'VCOSTI-ERROR-CANNOT FACTOR',IFAILN
          ENDIF
        STOP
      ENDIF
      IF(IFAIL.NE.0) IFAIL=IFAILN    
      RETURN
      END

      SUBROUTINE VRFFTB (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N
      REAL CR(1+INC*(N/2)+JMP*(M-1)),CI(1+INC*(N/2)+JMP*(M-1))
      REAL WR(1+INC*(N/2)+JMP*(M-1)),WI(1+INC*(N/2)+JMP*(M-1))
      REAL WSAVE(N+15)
      IF (N .EQ. 1) RETURN
      CALL RFFTB1 (CR,CI,WR,WI,N,M,INC,JMP,WSAVE,WSAVE(N+1))
      RETURN
      END
      SUBROUTINE RFFTB1 (CR,CI,WR,WI,N,M,INC,JMP,WA,IFAC)
      REAL CR(1+INC*(N/2)+JMP*(M-1)),CI(1+INC*(N/2)+JMP*(M-1))
      REAL WR(1+INC*(N/2)+JMP*(M-1)),WI(1+INC*(N/2)+JMP*(M-1))
      INTEGER IFAC(15)
      REAL WA(N)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 100 J=1,M
        JJ=1+JMP*(J-1)
        CI(JJ)=CR(JJ)
 100  CONTINUE
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF(IDO.EQ.1) THEN
           IF(NA.EQ.0) THEN
             IF(IP.EQ.4)CALL RADB4L (L1,INC,JMP,M,CR,CI,WR,WI)
             IF(IP.EQ.2)CALL RADB2L (L1,INC,JMP,M,CR,CI,WR,WI)
           ELSE      
             IF(IP.EQ.4)CALL RADB4L (L1,INC,JMP,M,WR,WI,CR,CI)
             IF(IP.EQ.2)CALL RADB2L (L1,INC,JMP,M,WR,WI,CR,CI)
           ENDIF
         ELSE
           IF(NA .EQ. 0) THEN
             IF(IP.EQ.4)CALL RADB4 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW),WA(IX2),WA(IX3))
             IF(IP.EQ.2)CALL RADB2 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW))
             IF(IP.EQ.3)CALL RADB3 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW),WA(IX2))
             IF(IP.EQ.5)CALL RADB5 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                WA(IW),WA(IX2),WA(IX3),WA(IX4))
           ELSE
             IF(IP.EQ.4)CALL RADB4 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &                   WA(IW),WA(IX2),WA(IX3))
             IF(IP.EQ.2)CALL RADB2 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &                   WA(IW))
             IF(IP.EQ.3)CALL RADB3 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &          WA(IW),WA(IX2))
             IF(IP.EQ.5)CALL RADB5 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &          WA(IW),WA(IX2),WA(IX3),WA(IX4))
           ENDIF
         ENDIF
         IF(IP.GT.5) THEN
           WRITE(*,*) 'FACTOR ',IP,' NOT IMPLEMENTED'
           STOP
         ENDIF
         NA=1-NA
         L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      IF (NA .NE. 0) THEN
        DO 117 I=1,N/2
        DO 117 J=1,M
          JJ=1+JMP*(J-1)
          CR(JJ+INC*(I-1)) = WR(JJ+INC*(I-1))
          CI(JJ+INC*(I-1)) = WI(JJ+INC*(I-1))
  117   CONTINUE
      ENDIF
      DO 118 J=1,M
        JJ=1+JMP*(J-1)
        CR(JJ+INC*(N/2)) = 0.0
        CI(JJ+INC*(N/2)) = 0.0
 118  CONTINUE
      RETURN
      END

      SUBROUTINE RADB2L (L1,INC,JMP,M,CCR,CCI,CHR,CHI)
      REAL CCR(INC,L1+1),CCI(INC,L1),CHR(INC,L1+1),CHI(INC,L1)
      IF(MOD(L1,2).EQ.0) THEN
        DO 101 K=1,L1/2
        DO 101 J=1,M
          JJ=1+JMP*(J-1)
          CHR(JJ,K) = CCI(JJ,2*K-1)+CCR(JJ,2*K)
          CHR(JJ,K+L1/2) = CCI(JJ,2*K-1)-CCR(JJ,2*K)
          CHI(JJ,K) = CCI(JJ,2*K)+CCR(JJ,2*K+1)
          CHI(JJ,K+L1/2) = CCI(JJ,2*K)-CCR(JJ,2*K+1)
 101    CONTINUE
      ELSE
        DO 102 K=1,L1/2
        DO 102 J=1,M
          JJ=1+JMP*(J-1)
          CHR(JJ,K) = CCI(JJ,2*K-1)+CCR(JJ,2*K)
          CHI(JJ,K+L1/2) = CCI(JJ,2*K-1)-CCR(JJ,2*K)
          CHI(JJ,K) = CCI(JJ,2*K)+CCR(JJ,2*K+1)
          CHR(JJ,K+L1/2+1) = CCI(JJ,2*K)-CCR(JJ,2*K+1)
 102      CONTINUE
        DO 103 J=1,M
          JJ=1+JMP*(J-1)
          CHR(JJ,L1/2+1) = CCI(JJ,L1)+CCR(JJ,L1+1)
          CHI(JJ,L1) = CCI(JJ,L1)-CCR(JJ,L1+1)
 103    CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE RADB2 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1)
      REAL CCR(INC,IDO/2,2,L1),CCI(INC,IDO/2,2,L1)
      REAL CHR(INC,IDO/2,L1,2),CHI(INC,IDO/2,L1,2)
      REAL WA1(1)
      DO 101 K=1,L1
      DO 101 J=1,M
        JJ=1+JMP*(J-1)
        CHI(JJ,1,K,1) = CCI(JJ,1,1,K)+CCR(JJ,IDO/2+1,2,K)
        CHI(JJ,1,K,2) = CCI(JJ,1,1,K)-CCR(JJ,IDO/2+1,2,K)
  101 CONTINUE
      IF (IDO.GT.2) THEN
        IDP2 = IDO/2+2
        DO 103 K=1,L1
        DO 103 I=2,IDO/2
          IC = IDP2-I
          DO 104 J=1,M
            JJ=1+JMP*(J-1)
            CHR(JJ,I,K,1) = CCR(JJ,I,1,K)+CCR(JJ,IC,2,K)
            TR2 = CCR(JJ,I,1,K)-CCR(JJ,IC,2,K)
            CHI(JJ,I,K,1) = CCI(JJ,I,1,K)-CCI(JJ,IC,2,K)
            TI2 = CCI(JJ,I,1,K)+CCI(JJ,IC,2,K)
            CHR(JJ,I,K,2) = WA1(2*I-3)*TR2-WA1(2*I-2)*TI2
            CHI(JJ,I,K,2) = WA1(2*I-3)*TI2+WA1(2*I-2)*TR2
  104     CONTINUE
  103   CONTINUE
      ENDIF
      DO 106 K=1,L1
      DO 106 J=1,M
        JJ=1+JMP*(J-1)
        CHR(JJ,IDO/2+1,K,1) = CCR(JJ,IDO/2+1,1,K)+CCR(JJ,IDO/2+1,1,K)
        CHR(JJ,IDO/2+1,K,2) = -(CCI(JJ,1,2,K)+CCI(JJ,1,2,K))
  106 CONTINUE
      RETURN
      END

      SUBROUTINE RADB3 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1,WA2)
      REAL CCR(INC,IDO/2,3,L1),CCI(INC,IDO/2,3,L1)
      REAL CHR(INC,IDO/2,L1,3),CHI(INC,IDO/2,L1,3)
      REAL  WA1(1)     ,WA2(1)
      DATA TAUR,TAUI /-.5,.866025403784439/
      DO 101 K=1,L1
      DO 101 J=1,M
         JJ=1+JMP*(J-1)
         TR2 = CCR(JJ,IDO/2+1,2,K)+CCR(JJ,IDO/2+1,2,K)
         CR2 = CCI(JJ,1,1,K)+TAUR*TR2
         CHI(JJ,1,K,1) = CCI(JJ,1,1,K)+TR2
         CI3 = TAUI*(CCI(JJ,1,3,K)+CCI(JJ,1,3,K))
         CHI(JJ,1,K,2) = CR2-CI3
         CHI(JJ,1,K,3) = CR2+CI3
  101 CONTINUE
      IDP2 = IDO/2+2
      DO 103 K=1,L1
      DO 103 I=2,IDO/2
        IC = IDP2-I
        DO 104 J=1,M
          JJ=1+JMP*(J-1)
          TR2 = CCR(JJ,I,3,K)+CCR(JJ,IC,2,K)
          CR3 = TAUI*(CCR(JJ,I,3,K)-CCR(JJ,IC,2,K))
          CR2 = CCR(JJ,I,1,K)+TAUR*TR2
          CHR(JJ,I,K,1) = CCR(JJ,I,1,K)+TR2
          TI2 = CCI(JJ,I,3,K)-CCI(JJ,IC,2,K)
          CI3 = TAUI*(CCI(JJ,I,3,K)+CCI(JJ,IC,2,K))
          CI2 = CCI(JJ,I,1,K)+TAUR*TI2
          CHI(JJ,I,K,1) = CCI(JJ,I,1,K)+TI2
          DR2 = CR2-CI3
          DI2 = CI2+CR3
          CHR(JJ,I,K,2) = WA1(2*I-3)*DR2-WA1(2*I-2)*DI2
          CHI(JJ,I,K,2) = WA1(2*I-3)*DI2+WA1(2*I-2)*DR2
C          DI3 = CI2-CR3
C          DR3 = CR2+CI3
          CHR(JJ,I,K,3) = WA2(2*I-3)*(CR2+CI3)-WA2(2*I-2)*(CI2-CR3)
          CHI(JJ,I,K,3) = WA2(2*I-3)*(CI2-CR3)+WA2(2*I-2)*(CR2+CI3)
  104   CONTINUE
  103 CONTINUE
      DO 106 K=1,L1
      DO 106 J=1,M
        JJ=1+JMP*(J-1)
        TR1 = CCR(JJ,IDO/2+1,1,K)-CCR(JJ,IDO/2+1,3,K)
        CHR(JJ,IDO/2+1,K,1) = 2.*CCR(JJ,IDO/2+1,1,K)+CCR(JJ,IDO/2+1,3,K)
        CHR(JJ,IDO/2+1,K,2) = TR1-(2.*TAUI)*CCI(JJ,1,2,K)
        CHR(JJ,IDO/2+1,K,3) = -TR1-(2.*TAUI)*CCI(JJ,1,2,K)
  106 CONTINUE
      RETURN
      END

      SUBROUTINE RADB4L (L1,INC,JMP,M,CCR,CCI,CHR,CHI)
      REAL CCR(INC,2,L1+1),CCI(INC,2,L1)
      REAL CHR(INC,(L1+1)/2,4),CHI(INC,(L1+1)/2,4)
      IF(MOD(L1,2).EQ.0) THEN
        DO 101 K=1,L1/2
        DO 101 J=1,M
           JJ=1+JMP*(J-1)
C          TR1 = CCI(JJ,1,2*K-1)-CCR(JJ,1,2*K)
C          TR2 = CCI(JJ,1,2*K-1)+CCR(JJ,1,2*K)
C          TR3 = 2.*CCR(JJ,2,2*K-1)
C          TR4 = 2.*CCI(JJ,2,2*K-1)
          CHR(JJ,K,4) = CCI(JJ,1,2*K-1)-CCR(JJ,1,2*K)+2.*CCI(JJ,2,2*K-1)
          CHR(JJ,K,2) = CCI(JJ,1,2*K-1)-CCR(JJ,1,2*K)-2.*CCI(JJ,2,2*K-1)
          CHR(JJ,K,1) = CCI(JJ,1,2*K-1)+CCR(JJ,1,2*K)+2.*CCR(JJ,2,2*K-1)
          CHR(JJ,K,3) = CCI(JJ,1,2*K-1)+CCR(JJ,1,2*K)-2.*CCR(JJ,2,2*K-1)
C          TI1 = CCI(JJ,1,2*K)-CCR(JJ,1,2*K+1)
C          TI2 = CCI(JJ,1,2*K)+CCR(JJ,1,2*K+1)
C          TI3 = 2.*CCR(JJ,2,2*K)
C          TI4 = 2.*CCI(JJ,2,2*K)
          CHI(JJ,K,4) = CCI(JJ,1,2*K)-CCR(JJ,1,2*K+1)+2.*CCI(JJ,2,2*K)
          CHI(JJ,K,2) = CCI(JJ,1,2*K)-CCR(JJ,1,2*K+1)-2.*CCI(JJ,2,2*K)
          CHI(JJ,K,1) = CCI(JJ,1,2*K)+CCR(JJ,1,2*K+1)+2.*CCR(JJ,2,2*K)
          CHI(JJ,K,3) = CCI(JJ,1,2*K)+CCR(JJ,1,2*K+1)-2.*CCR(JJ,2,2*K)
 101    CONTINUE
      ELSE
        DO 102 K=1,L1/2
        DO 102 J=1,M
          JJ=1+JMP*(J-1)
          TR1 = CCI(JJ,1,2*K-1)-CCR(JJ,1,2*K)
          TR2 = CCI(JJ,1,2*K-1)+CCR(JJ,1,2*K)
          TR3 = CCR(JJ,2,2*K-1)+CCR(JJ,2,2*K-1)
          TR4 = CCI(JJ,2,2*K-1)+CCI(JJ,2,2*K-1)
          CHR(JJ,K,1) = TR2+TR3
          CHR(JJ,K-1,3) = TR2-TR3
          CHI(JJ,K-2,4) = TR1+TR4
          CHI(JJ,K-1,2) = TR1-TR4
          TR1 = CCI(JJ,1,2*K)-CCR(JJ,1,2*K+1)
          TR2 = CCI(JJ,1,2*K)+CCR(JJ,1,2*K+1)
          TR3 = CCR(JJ,2,2*K)+CCR(JJ,2,2*K)
          TR4 = CCI(JJ,2,2*K)+CCI(JJ,2,2*K)
          CHI(JJ,K,1) = TR2+TR3
          CHI(JJ,K-1,3) = TR2-TR3
          CHR(JJ,K-1,4) = TR1+TR4
          CHR(JJ,K,2) = TR1-TR4
 102    CONTINUE
        DO 103 J=1,M
          JJ=1+JMP*(J-1)
          TR1 = CCI(JJ,1,L1)-CCR(JJ,1,L1+1)
          TR2 = CCI(JJ,1,L1)+CCR(JJ,1,L1+1)
          TR3 = 2.*CCR(JJ,2,L1)
          TR4 = 2.*CCI(JJ,2,L1)
          CHR(JJ,L1/2+1,1) = TR2+TR3
          CHR(JJ,L1/2,3) = TR2-TR3
          CHI(JJ,L1/2-1,4) = TR1+TR4
          CHI(JJ,L1/2,2) = TR1-TR4
 103    CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE RADB4 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1,WA2,WA3)
      REAL CCR(INC,IDO/2,4,L1),CCI(INC,IDO/2,4,L1)
      REAL CHR(INC,IDO/2,L1,4),CHI(INC,IDO/2,L1,4)
      REAL WA1(1)     ,WA2(1)     ,WA3(1)
      DATA SQRT2 /1.414213562373095/
      DO 101 K=1,L1
      DO 101 J=1,M
        JJ=1+JMP*(J-1)
        TR1 = CCI(JJ,1,1,K)-CCR(JJ,IDO/2+1,4,K)
        TR2 = CCI(JJ,1,1,K)+CCR(JJ,IDO/2+1,4,K)
C        TR3 = 2.*CCR(JJ,IDO/2+1,2,K)
C        TR4 = 2.*CCI(JJ,1,3,K)
        CHI(JJ,1,K,4) = TR1+2.*CCI(JJ,1,3,K)
        CHI(JJ,1,K,2) = TR1-2.*CCI(JJ,1,3,K)
        CHI(JJ,1,K,1) = TR2+2.*CCR(JJ,IDO/2+1,2,K)
        CHI(JJ,1,K,3) = TR2-2.*CCR(JJ,IDO/2+1,2,K)
  101 CONTINUE
      IF (IDO.GT.2) THEN
        IDP2 = IDO/2+2
        DO 104 K=1,L1
        DO 104 I=2,IDO/2
          IC = IDP2-I
          DO 103 J=1,M
            JJ=1+JMP*(J-1)
            TR3 = CCR(JJ,I,3,K)+CCR(JJ,IC,2,K)
            TI4 = CCR(JJ,I,3,K)-CCR(JJ,IC,2,K)
            TR2 = CCR(JJ,I,1,K)+CCR(JJ,IC,4,K)
            CR3 = TR2-TR3
            TR1 = CCR(JJ,I,1,K)-CCR(JJ,IC,4,K)
            CHR(JJ,I,K,1) = TR2+TR3
            TI1 = CCI(JJ,I,1,K)+CCI(JJ,IC,4,K)
            TI2 = CCI(JJ,I,1,K)-CCI(JJ,IC,4,K)
            TI3 = CCI(JJ,I,3,K)-CCI(JJ,IC,2,K)
            CHI(JJ,I,K,1) = TI2+TI3
            TR4 = CCI(JJ,I,3,K)+CCI(JJ,IC,2,K)
C            CI3 = TI2-TI3
            CHR(JJ,I,K,3) = WA2(2*I-3)*CR3-WA2(2*I-2)*(TI2-TI3)
            CHI(JJ,I,K,3) = WA2(2*I-3)*(TI2-TI3)+WA2(2*I-2)*CR3
C            CR2 = TR1-TR4
C            CR4 = TR1+TR4
C            CI2 = TI1+TI4
C            CI4 = TI1-TI4
            CHR(JJ,I,K,2) = WA1(2*I-3)*(TR1-TR4)-WA1(2*I-2)*(TI1+TI4)
            CHI(JJ,I,K,2) = WA1(2*I-3)*(TI1+TI4)+WA1(2*I-2)*(TR1-TR4)
            CHR(JJ,I,K,4) = WA3(2*I-3)*(TR1+TR4)-WA3(2*I-2)*(TI1-TI4)
            CHI(JJ,I,K,4) = WA3(2*I-3)*(TI1-TI4)+WA3(2*I-2)*(TR1+TR4)
  103     CONTINUE
  104   CONTINUE
      ENDIF
      DO 106 K=1,L1
      DO 106 J=1,M
         JJ=1+JMP*(J-1)
         TI1 = CCI(JJ,1,2,K)+CCI(JJ,1,4,K)
C         TI2 = CCI(JJ,1,4,K)-CCI(JJ,1,2,K)
         CHR(JJ,IDO/2+1,K,3) = 2.*(CCI(JJ,1,4,K)-CCI(JJ,1,2,K))
         TR1 = CCR(JJ,IDO/2+1,1,K)-CCR(JJ,IDO/2+1,3,K)
C         TR2 = CCR(JJ,IDO/2+1,1,K)+CCR(JJ,IDO/2+1,3,K)
         CHR(JJ,IDO/2+1,K,1) = 
     &        2.*(CCR(JJ,IDO/2+1,1,K)+CCR(JJ,IDO/2+1,3,K))
         CHR(JJ,IDO/2+1,K,2) = SQRT2*(TR1-TI1)
         CHR(JJ,IDO/2+1,K,4) = -SQRT2*(TR1+TI1)
  106 CONTINUE
      RETURN
      END
      SUBROUTINE RADB5 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,
     &WA1,WA2,WA3,WA4)
      REAL CCR(INC,IDO/2,5,L1),CCI(INC,IDO/2,5,L1)
      REAL CHR(INC,IDO/2,L1,5),CHI(INC,IDO/2,L1,5)
      REAL WA1(1)     ,WA2(1)     ,WA3(1)     ,WA4(1)
      DATA TR11,TI11,TR12,TI12,TR13 /.309016994374947,.951056516295155,
     1-.809016994374947,.587785252292473,.55901699437495/
      DO 101 K=1,L1
      DO 101 J=1,M
         JJ=1+JMP*(J-1)
         TI5 = CCI(JJ,1,3,K)+CCI(JJ,1,3,K)
         TI4 = CCI(JJ,1,5,K)+CCI(JJ,1,5,K)
         TR2 = CCR(JJ,IDO/2+1,2,K)+CCR(JJ,IDO/2+1,2,K)
         TR3 = CCR(JJ,IDO/2+1,4,K)+CCR(JJ,IDO/2+1,4,K)
         CHI(JJ,1,K,1) = CCI(JJ,1,1,K)+TR2+TR3
         CR2 = CCI(JJ,1,1,K)+TR11*TR2+TR12*TR3
         CR3 = CCI(JJ,1,1,K)+TR12*TR2+TR11*TR3
         CI5 = TI11*TI5+TI12*TI4
         CI4 = TI12*TI5-TI11*TI4
         CHI(JJ,1,K,2) = CR2-CI5
         CHI(JJ,1,K,3) = CR3-CI4
         CHI(JJ,1,K,4) = CR3+CI4
         CHI(JJ,1,K,5) = CR2+CI5
  101 CONTINUE
      IDP2 = IDO/2+2
      DO 103 K=1,L1
      DO 103 I=2,IDO/2
        IC = IDP2-I
        DO 102 J=1,M
            JJ=1+JMP*(J-1)
            TI5 = CCI(JJ,I,3,K)+CCI(JJ,IC,2,K)
            TI2 = CCI(JJ,I,3,K)-CCI(JJ,IC,2,K)
            TI4 = CCI(JJ,I,5,K)+CCI(JJ,IC,4,K)
            CI5 = TI11*TI5+TI12*TI4
            CI4 = TI12*TI5-TI11*TI4
            TI3 = CCI(JJ,I,5,K)-CCI(JJ,IC,4,K)
            CI2 = CCI(JJ,I,1,K)+TR11*TI2+TR12*TI3
            CI3 = CCI(JJ,I,1,K)+TR12*TI2+TR11*TI3
            CHI(JJ,I,K,1) = CCI(JJ,I,1,K)+TI2+TI3
            TR5 = CCR(JJ,I,3,K)-CCR(JJ,IC,2,K)
            TR2 = CCR(JJ,I,3,K)+CCR(JJ,IC,2,K)
            TR4 = CCR(JJ,I,5,K)-CCR(JJ,IC,4,K)
            CR5 = TI11*TR5+TI12*TR4
            CR4 = TI12*TR5-TI11*TR4
            TR3 = CCR(JJ,I,5,K)+CCR(JJ,IC,4,K)
            CR2 = CCR(JJ,I,1,K)+TR11*TR2+TR12*TR3
            CR3 = CCR(JJ,I,1,K)+TR12*TR2+TR11*TR3
            CHR(JJ,I,K,1) = CCR(JJ,I,1,K)+TR2+TR3
            DR3 = CR3-CI4
            DR4 = CR3+CI4
            DI3 = CI3+CR4
            DI4 = CI3-CR4
            CHR(JJ,I,K,3) = WA2(2*I-3)*DR3-WA2(2*I-2)*DI3
            CHI(JJ,I,K,3) = WA2(2*I-3)*DI3+WA2(2*I-2)*DR3
            CHR(JJ,I,K,4) = WA3(2*I-3)*DR4-WA3(2*I-2)*DI4
            CHI(JJ,I,K,4) = WA3(2*I-3)*DI4+WA3(2*I-2)*DR4
            DR5 = CR2+CI5
            DR2 = CR2-CI5
            DI5 = CI2-CR5
            DI2 = CI2+CR5
            CHR(JJ,I,K,2) = WA1(2*I-3)*DR2-WA1(2*I-2)*DI2
            CHI(JJ,I,K,2) = WA1(2*I-3)*DI2+WA1(2*I-2)*DR2
            CHR(JJ,I,K,5) = WA4(2*I-3)*DR5-WA4(2*I-2)*DI5
            CHI(JJ,I,K,5) = WA4(2*I-3)*DI5+WA4(2*I-2)*DR5
  102     CONTINUE
  103 CONTINUE
      DO 106 K=1,L1
      DO 106 J=1,M
         JJ=1+JMP*(J-1)
         T1 = CCR(JJ,IDO/2+1,1,K)+CCR(JJ,IDO/2+1,3,K)
         T2 = .5*T1-CCR(JJ,IDO/2+1,5,K)
         T3 = (2.*TR13)*(CCR(JJ,IDO/2+1,1,K)-CCR(JJ,IDO/2+1,3,K))
         T4 = (2.*TI12)*CCI(JJ,1,2,K)+(2.*TI11)*CCI(JJ,1,4,K) 
         T5 = (2.*TI11)*CCI(JJ,1,2,K)-(2.*TI12)*CCI(JJ,1,4,K)
         T6 = T3+T2
         T7 = T3-T2
         CHR(JJ,IDO/2+1,K,1) = CCR(JJ,IDO/2+1,5,K)+2.*T1
         CHR(JJ,IDO/2+1,K,2) = T6-T4
         CHR(JJ,IDO/2+1,K,3) = T7-T5
         CHR(JJ,IDO/2+1,K,4) = -T7-T5
         CHR(JJ,IDO/2+1,K,5) = -T6-T4
  106 CONTINUE
      RETURN
      END




      SUBROUTINE VRFFTF (CR,CI,WR,WI,N,M,INC,JMP,WSAVE)
      IMPLICIT LOGICAL(A-Z)
      INTEGER INC,JMP,M,N
      REAL CR(1+INC*(N/2)+JMP*(M-1)),CI(1+INC*(N/2)+JMP*(M-1))
      REAL WR(1+INC*(N/2)+JMP*(M-1)),WI(1+INC*(N/2)+JMP*(M-1))
      REAL WSAVE(N+15)
      INTEGER J
      IF (N .EQ. 1) RETURN
      CALL RFFTF1 (CR,CI,WR,WI,N,M,INC,JMP,WSAVE,WSAVE(N+1))
      DO 117 J=1,M
        CI(1+JMP*(J-1)+INC*N/2)=0.
 117  CONTINUE
      RETURN
      END
      SUBROUTINE RFFTF1 (CR,CI,WR,WI,N,M,INC,JMP,WA,IFAC)
      IMPLICIT LOGICAL(A-Z)
      INTEGER N,M,INC,JMP,IFAC(15)
      REAL WA(N)
      REAL CR(1+INC*(N/2)+JMP*(M-1)),CI(1+INC*(N/2)+JMP*(M-1))
      REAL WR(1+INC*(N/2)+JMP*(M-1)),WI(1+INC*(N/2)+JMP*(M-1))
      INTEGER NF,NA,L2,IW,K1,KH,IDO,IDL1,IP,L1,IX2,IX3,IX4,I,J,II
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF(IDO.EQ.1) THEN
           IF(IP.EQ.4)CALL RADF4F (L1,INC,JMP,M,CR,CI,WR,WI)
           IF(IP.EQ.2)CALL RADF2F (L1,INC,JMP,M,CR,CI,WR,WI)
         ELSE
           IF(NA .EQ. 0) THEN
             IF(IP.EQ.4)CALL RADF4 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW),WA(IX2),WA(IX3))
             IF(IP.EQ.2)CALL RADF2 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW))
             IF(IP.EQ.3)CALL RADF3 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                   WA(IW),WA(IX2))
             IF(IP.EQ.5)CALL RADF5 (IDO,L1,INC,JMP,M,CR,CI,WR,WI,
     &                WA(IW),WA(IX2),WA(IX3),WA(IX4))
           ELSE
             IF(IP.EQ.4)CALL RADF4 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &                   WA(IW),WA(IX2),WA(IX3))
             IF(IP.EQ.2)CALL RADF2 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &                   WA(IW))
             IF(IP.EQ.3)CALL RADF3 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &          WA(IW),WA(IX2))
             IF(IP.EQ.5)CALL RADF5 (IDO,L1,INC,JMP,M,WR,WI,CR,CI,
     &          WA(IW),WA(IX2),WA(IX3),WA(IX4))
           ENDIF
         ENDIF
           IF(IP.GT.5)THEN
             WRITE(*,*) 'FACTOR ',IP,' NOT IMPLEMENTED'
             STOP
           ENDIF
        L2 = L1
  111 CONTINUE
      IF (NA .EQ. 0) THEN
        DO 112 I=2,N/2
        DO 112 J=1,M
          II=1+JMP*(J-1)+INC*(I-1)
          CR(II) = WR(II)
          CI(II) = WI(II)
  112   CONTINUE
        DO 116 J=1,M
          CR(1+JMP*(J-1))=WI(1+JMP*(J-1))
 116   CONTINUE
        DO 113 J=1,M
          CR(1+JMP*(J-1)+INC*N/2)=WR(1+JMP*(J-1)+INC*N/2)
 113    CONTINUE    
      ELSE
        DO 114 J=1,M
          CR(1+JMP*(J-1))=CI(1+JMP*(J-1))
 114      CONTINUE  
      ENDIF
        DO 115 J=1,M
          CI(1+JMP*(J-1))=0.
 115    CONTINUE
      RETURN
      END


      SUBROUTINE RADF2F (L1,INC,JMP,M,CCR,CCI,CHR,CHI)
      REAL CCR(INC,1),CCI(INC,1)
      REAL  CHR(INC,2,1),CHI(INC,2,1)
      IF(MOD(L1,2).EQ.0) THEN
      DO 101 K=1,L1/2
      DO 101 J=1,M
        JJ=1+JMP*(J-1)
        CHI(JJ,1,K) = CCR(JJ,K)+CCR(JJ,K+L1/2)
        CHR(JJ,2,K) = CCR(JJ,K)-CCR(JJ,K+L1/2)
        CHI(JJ,2,K) = CCI(JJ,K)+CCI(JJ,K+L1/2)
        CHR(JJ,1,K+1) = CCI(JJ,K)-CCI(JJ,K+L1/2)
 101  CONTINUE
      ELSE
      DO 102 K=1,L1/2
      DO 102 J=1,M
        JJ=1+JMP*(J-1)
        CHI(JJ,1,K) = CCR(JJ,K)+CCI(JJ,K+L1/2)
        CHR(JJ,2,K) = CCR(JJ,K)-CCI(JJ,K+L1/2)
        CHI(JJ,2,K) = CCI(JJ,K)+CCR(JJ,K+L1/2+1)
        CHR(JJ,1,K+1) = CCI(JJ,K)-CCR(JJ,K+L1/2+1)
 102    CONTINUE
      DO 103 J=1,M
        JJ=1+JMP*(J-1)
        CHI(JJ,1,L1/2+1) = CCR(JJ,L1/2+1)+CCI(JJ,L1)
        CHR(JJ,2,L1/2+1) = CCR(JJ,L1/2+1)-CCI(JJ,L1)
 103  CONTINUE
      ENDIF
      RETURN
      END

      SUBROUTINE RADF2 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1)
      REAL CHR(INC,IDO/2,2,L1),CHI(INC,IDO/2,2,L1)
      REAL WA1(IDO-1),CCR(INC,IDO/2,L1,2),CCI(INC,IDO/2,L1,2)
      DO 101 K=1,L1
      DO 101 J=1,M
         JJ=1+JMP*(J-1)
         CHI(JJ,1,1,K) = CCI(JJ,1,K,1)+CCI(JJ,1,K,2)
         CHR(JJ,IDO/2+1,2,K) = CCI(JJ,1,K,1)-CCI(JJ,1,K,2)
  101 CONTINUE
      IF (IDO.GT.2) THEN
        IDP2 = IDO/2+2
        DO 104 K=1,L1
        DO 104 I=2,IDO/2
          IC = IDP2-I
          DO 105 J=1,M
            JJ=1+JMP*(J-1)
            TR2 = WA1(2*I-3)*CCR(JJ,I,K,2)+WA1(2*I-2)*CCI(JJ,I,K,2)
            TI2 = WA1(2*I-3)*CCI(JJ,I,K,2)-WA1(2*I-2)*CCR(JJ,I,K,2)
            CHI(JJ,I,1,K) = CCI(JJ,I,K,1)+TI2
            CHI(JJ,IC,2,K) = TI2-CCI(JJ,I,K,1)
            CHR(JJ,I,1,K) = CCR(JJ,I,K,1)+TR2
            CHR(JJ,IC,2,K) = CCR(JJ,I,K,1)-TR2
 105     CONTINUE
 104  CONTINUE
      ENDIF
      DO 106 K=1,L1
      DO 106 J=1,M
        JJ=1+JMP*(J-1)
        CHI(JJ,1,2,K) = -CCR(JJ,IDO/2+1,K,2)
        CHR(JJ,IDO/2+1,1,K) = CCR(JJ,IDO/2+1,K,1)
106   CONTINUE
      RETURN
      END

      SUBROUTINE RADF3 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1,WA2)
      REAL  CHR(INC,IDO/2,3,L1),CHI(INC,IDO/2,3,L1)
      REAL  CCR(INC,IDO/2,L1,3),CCI(INC,IDO/2,L1,3), WA1(1),WA2(1)
      REAL TAUR,TAUI
      DATA TAUR,TAUI /-.5,.866025403784439/
      DO 101 K=1,L1
      DO 101 J=1,M
          JJ=1+JMP*(J-1)
          CR2 = CCI(JJ,1,K,2)+CCI(JJ,1,K,3)
          CHI(JJ,1,1,K) = CCI(JJ,1,K,1)+CR2
          CHI(JJ,1,3,K) = TAUI*(CCI(JJ,1,K,3)-CCI(JJ,1,K,2))
          CHR(JJ,IDO/2+1,2,K) = CCI(JJ,1,K,1)+TAUR*CR2
  101 CONTINUE
      IDP2 = IDO/2+2
      DO 102 K=1,L1
      DO 102 I=2,IDO/2
        IC = IDP2-I
        DO 103 J=1,M
          JJ=1+JMP*(J-1)
          DR2 = WA1(2*I-3)*CCR(JJ,I,K,2)+WA1(2*I-2)*CCI(JJ,I,K,2)
          DI2 = WA1(2*I-3)*CCI(JJ,I,K,2)-WA1(2*I-2)*CCR(JJ,I,K,2)
          DR3 = WA2(2*I-3)*CCR(JJ,I,K,3)+WA2(2*I-2)*CCI(JJ,I,K,3)
          DI3 = WA2(2*I-3)*CCI(JJ,I,K,3)-WA2(2*I-2)*CCR(JJ,I,K,3)
C          CR2 = DR2+DR3
C          CI2 = DI2+DI3
          CHR(JJ,I,1,K) = CCR(JJ,I,K,1)+(DR2+DR3)
          TR2 = CCR(JJ,I,K,1)+TAUR*(DR2+DR3)
          CHI(JJ,I,1,K) = CCI(JJ,I,K,1)+(DI2+DI3)
          TI2 = CCI(JJ,I,K,1)+TAUR*(DI2+DI3)
          TR3 = TAUI*(DI2-DI3)
          TI3 = TAUI*(DR3-DR2)
          CHR(JJ,I,3,K) = TR2+TR3
          CHR(JJ,IC,2,K) = TR2-TR3
          CHI(JJ,I,3,K) = TI2+TI3
          CHI(JJ,IC,2,K) = TI3-TI2
 103    CONTINUE
 102  CONTINUE
      DO 106 K=1,L1
      DO 106 J=1,M
         JJ=1+JMP*(J-1)
         T1 = CCR(JJ,IDO/2+1,K,2)-CCR(JJ,IDO/2+1,K,3)
         CHR(JJ,IDO/2+1,1,K) = .5*T1+CCR(JJ,IDO/2+1,K,1)
         CHR(JJ,IDO/2+1,3,K) = CCR(JJ,IDO/2+1,K,1)-T1
         CHI(JJ,1,2,K) = -TAUI*(CCR(JJ,IDO/2+1,K,2)+CCR(JJ,IDO/2+1,K,3))
  106 CONTINUE
      RETURN
      END
      SUBROUTINE RADF4F (L1,INC,JMP,M,CCR,CCI,CHR,CHI)
      REAL CCR(INC,2*L1+1),CCI(INC,2*L1),CHR(INC,4,L1+1),CHI(INC,4,L1)
      IF(MOD(L1,2).EQ.0) THEN
        DO 101 K=1,L1/2
        DO 101 J=1,M
          JJ=1+JMP*(J-1)
          TR1 = CCR(JJ,K+L1/2)+CCR(JJ,K+3*L1/2)
          CHI(JJ,2,K) = CCR(JJ,K+3*L1/2)-CCR(JJ,K+L1/2)
          TR2 = CCR(JJ,K)+CCR(JJ,K+L1)
          CHR(JJ,2,K) = CCR(JJ,K)-CCR(JJ,K+L1)
          CHI(JJ,1,K) = TR1+TR2
          CHR(JJ,3,K) = TR2-TR1
          TR1 = CCI(JJ,K+L1/2)+CCI(JJ,K+3*L1/2)
          CHI(JJ,4,K) = CCI(JJ,K+3*L1/2)-CCI(JJ,K+L1/2)
          TR2 = CCI(JJ,K)+CCI(JJ,K+L1)
          CHR(JJ,4,K) = CCI(JJ,K)-CCI(JJ,K+L1)
          CHI(JJ,3,K) = TR1+TR2
          CHR(JJ,1,K+1) = TR2-TR1
 101    CONTINUE
      ELSE
        DO 102 K=1,L1/2
        DO 102 J=1,M
          JJ=1+JMP*(J-1)
          TR1 = CCI(JJ,K+L1/2)+CCI(JJ,K+3*L1/2)
          CHI(JJ,2,K) = CCI(JJ,K+3*L1/2)-CCI(JJ,K+L1/2)
          TR2 = CCR(JJ,K)+CCR(JJ,K+L1)
          CHR(JJ,2,K) = CCR(JJ,K)-CCR(JJ,K+L1)
          CHI(JJ,1,K) = TR1+TR2
          CHR(JJ,3,K) = TR2-TR1
          TR1 = CCR(JJ,K+L1/2+1)+CCR(JJ,K+3*L1/2+1)
          CHI(JJ,4,K) = CCR(JJ,K+3*L1/2+1)-CCR(JJ,K+L1/2+1)
          TR2 = CCI(JJ,K)+CCI(JJ,K+L1)
          CHR(JJ,4,K) = CCI(JJ,K)-CCI(JJ,K+L1)
          CHI(JJ,3,K) = TR1+TR2
          CHR(JJ,1,K+1) = TR2-TR1
 102    CONTINUE
        DO 103 J=1,M
          JJ=1+JMP*(J-1)
          TR1 = CCI(JJ,L1)+CCI(JJ,2*L1)
          TR2 = CCR(JJ,L1/2+1)+CCR(JJ,3*L1/2+1)
          CHI(JJ,1,L1/2+1) = TR1+TR2
          CHR(JJ,3,L1/2+1) = TR2-TR1
          CHR(JJ,2,L1/2+1) = CCR(JJ,L1/2+1)-CCR(JJ,3*L1/2+1)
          CHI(JJ,2,L1/2+1) = CCI(JJ,2*L1)-CCI(JJ,L1)
 103    CONTINUE
      ENDIF
      RETURN
      END


      SUBROUTINE RADF4 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,WA1,WA2,WA3)
      REAL CCR(INC,IDO/2,L1,4),CCI(INC,IDO/2,L1,4)
      REAL CHR(INC,IDO/2,4,L1),CHI(INC,IDO/2,4,L1)
      REAL WA1(1)     ,WA2(1)     ,WA3(1)
      DATA HSQT2 /.7071067811865475/
      DO 101 K=1,L1
      DO 101 J=1,M
         JJ=1+JMP*(J-1)
         TR1 = CCI(JJ,1,K,2)+CCI(JJ,1,K,4)
         TR2 = CCI(JJ,1,K,1)+CCI(JJ,1,K,3)
         CHI(JJ,1,1,K) = TR1+TR2
         CHR(JJ,IDO/2+1,4,K) = TR2-TR1
         CHR(JJ,IDO/2+1,2,K) = CCI(JJ,1,K,1)-CCI(JJ,1,K,3)
         CHI(JJ,1,3,K) = CCI(JJ,1,K,4)-CCI(JJ,1,K,2)
  101 CONTINUE
      IF (IDO.GT.2) THEN
  102   IDP2 = IDO/2+2
        DO 104 K=1,L1
        DO 104 I=2,IDO/2
          IC = IDP2-I
          DO 103 J=1,M
            JJ=1+JMP*(J-1)
            CR2 = WA1(2*I-3)*CCR(JJ,I,K,2)+WA1(2*I-2)*CCI(JJ,I,K,2)
            CI2 = WA1(2*I-3)*CCI(JJ,I,K,2)-WA1(2*I-2)*CCR(JJ,I,K,2)
            CR4 = WA3(2*I-3)*CCR(JJ,I,K,4)+WA3(2*I-2)*CCI(JJ,I,K,4)
            CI4 = WA3(2*I-3)*CCI(JJ,I,K,4)-WA3(2*I-2)*CCR(JJ,I,K,4)
C            TR1 = CR2+CR4
C            TR4 = CR4-CR2
C            TI1 = CI2+CI4
C            TI4 = CI2-CI4
            CR3 = WA2(2*I-3)*CCR(JJ,I,K,3)+WA2(2*I-2)*CCI(JJ,I,K,3)
            CI3 = WA2(2*I-3)*CCI(JJ,I,K,3)-WA2(2*I-2)*CCR(JJ,I,K,3)
            TI2 = CCI(JJ,I,K,1)+CI3
            TI3 = CCI(JJ,I,K,1)-CI3
            CHI(JJ,I,1,K) = (CI2+CI4)+TI2
            CHI(JJ,IC,4,K) = (CI2+CI4)-TI2
            CHI(JJ,I,3,K) = (CR4-CR2)+TI3
            CHI(JJ,IC,2,K) = (CR4-CR2)-TI3
C            TR2 = CCR(JJ,I,K,1)+CR3
C            TR3 = CCR(JJ,I,K,1)-CR3
            CHR(JJ,I,1,K) = (CR2+CR4)+(CCR(JJ,I,K,1)+CR3)
            CHR(JJ,IC,4,K) = (CCR(JJ,I,K,1)+CR3)-(CR2+CR4)
            CHR(JJ,I,3,K) = (CI2-CI4)+(CCR(JJ,I,K,1)-CR3)
            CHR(JJ,IC,2,K) = (CCR(JJ,I,K,1)-CR3)-(CI2-CI4)
  103     CONTINUE
  104   CONTINUE
      ENDIF
      DO 106 K=1,L1
      DO 106 J=1,M
         JJ=1+JMP*(J-1)
         TI1 = -HSQT2*(CCR(JJ,IDO/2+1,K,2)+CCR(JJ,IDO/2+1,K,4))
         TR1 = HSQT2*(CCR(JJ,IDO/2+1,K,2)-CCR(JJ,IDO/2+1,K,4))
         CHR(JJ,IDO/2+1,1,K) = TR1+CCR(JJ,IDO/2+1,K,1)
         CHR(JJ,IDO/2+1,3,K) = CCR(JJ,IDO/2+1,K,1)-TR1
         CHI(JJ,1,2,K) = TI1-CCR(JJ,IDO/2+1,K,3)
         CHI(JJ,1,4,K) = TI1+CCR(JJ,IDO/2+1,K,3)
  106 CONTINUE
  107 RETURN
      END

      SUBROUTINE RADF5 (IDO,L1,INC,JMP,M,CCR,CCI,CHR,CHI,
     &                  WA1,WA2,WA3,WA4)
      REAL CCR(INC,IDO/2,L1,5),CCI(INC,IDO/2,L1,5)
      REAL CHR(INC,IDO/2,5,L1),CHI(INC,IDO/2,5,L1)
      REAL WA1(1)     ,WA2(1)     ,WA3(1)     ,WA4(1)
      DATA TR11,TI11,TR12,TI12,TR13 /.309016994374947,.951056516295154,
     1-.809016994374947,.587785252292473,.55901699437495/
      DO 101 K=1,L1
      DO 101 J=1,M
        JJ=1+JMP*(J-1)
        CR2 = CCI(JJ,1,K,5)+CCI(JJ,1,K,2)
        CI5 = CCI(JJ,1,K,5)-CCI(JJ,1,K,2)
        CI4 = CCI(JJ,1,K,4)-CCI(JJ,1,K,3)
        CHI(JJ,1,3,K) = TI11*CI5+TI12*CI4
        CHI(JJ,1,5,K) = TI12*CI5-TI11*CI4
        CR3 = CCI(JJ,1,K,4)+CCI(JJ,1,K,3)
        CHI(JJ,1,1,K) = CCI(JJ,1,K,1)+CR2+CR3
        CHR(JJ,IDO/2+1,2,K) = CCI(JJ,1,K,1)+TR11*CR2+TR12*CR3
        CHR(JJ,IDO/2+1,4,K) = CCI(JJ,1,K,1)+TR12*CR2+TR11*CR3
 101  CONTINUE
      IF(IDO.GT.2) THEN
        IDP2 = IDO/2+2
        DO 103 K=1,L1
        DO 103 I=2,IDO/2
          IC = IDP2-I
          DO 102 J=1,M
            JJ=1+JMP*(J-1)
            DR2 = WA1(2*I-3)*CCR(JJ,I,K,2)+WA1(2*I-2)*CCI(JJ,I,K,2)
            DI2 = WA1(2*I-3)*CCI(JJ,I,K,2)-WA1(2*I-2)*CCR(JJ,I,K,2)
            DR3 = WA2(2*I-3)*CCR(JJ,I,K,3)+WA2(2*I-2)*CCI(JJ,I,K,3)
            DI3 = WA2(2*I-3)*CCI(JJ,I,K,3)-WA2(2*I-2)*CCR(JJ,I,K,3)
            DR4 = WA3(2*I-3)*CCR(JJ,I,K,4)+WA3(2*I-2)*CCI(JJ,I,K,4)
            DI4 = WA3(2*I-3)*CCI(JJ,I,K,4)-WA3(2*I-2)*CCR(JJ,I,K,4)
            DR5 = WA4(2*I-3)*CCR(JJ,I,K,5)+WA4(2*I-2)*CCI(JJ,I,K,5)
            DI5 = WA4(2*I-3)*CCI(JJ,I,K,5)-WA4(2*I-2)*CCR(JJ,I,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CHR(JJ,I,1,K) = CCR(JJ,I,K,1)+CR2+CR3
            TR2 = CCR(JJ,I,K,1)+TR11*CR2+TR12*CR3
            TR3 = CCR(JJ,I,K,1)+TR12*CR2+TR11*CR3
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CHI(JJ,I,1,K) = CCI(JJ,I,K,1)+CI2+CI3
            TI2 = CCI(JJ,I,K,1)+TR11*CI2+TR12*CI3
            TI3 = CCI(JJ,I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TR4 = TI12*CR5-TI11*CR4
            CHR(JJ,I,5,K) = TR3+TR4
            CHR(JJ,IC,4,K) = TR3-TR4
            CHR(JJ,I,3,K) = TR2+TR5
            CHR(JJ,IC,2,K) = TR2-TR5
            TI5 = TI11*CI5+TI12*CI4
            TI4 = TI12*CI5-TI11*CI4
            CHI(JJ,I,3,K) = TI2+TI5
            CHI(JJ,IC,2,K) = TI5-TI2
            CHI(JJ,I,5,K) = TI3+TI4
            CHI(JJ,IC,4,K) = TI4-TI3
  102     CONTINUE
  103   CONTINUE
      ENDIF
      IF (MOD(IDO,2) .EQ. 1) RETURN
      DO 106 K=1,L1
      DO 106 J=1,M
         JJ=1+JMP*(J-1)
         T2 = CCR(JJ,IDO/2+1,K,2)+CCR(JJ,IDO/2+1,K,5)
         T1 = CCR(JJ,IDO/2+1,K,2)-CCR(JJ,IDO/2+1,K,5)
         T4 = CCR(JJ,IDO/2+1,K,3)+CCR(JJ,IDO/2+1,K,4)
         T3 = CCR(JJ,IDO/2+1,K,3)-CCR(JJ,IDO/2+1,K,4)
         T5 = T1-T3
         T6 = CCR(JJ,IDO/2+1,K,1)+.25*T5
         T7 = TR13*(T1+T3)
         CHR(JJ,IDO/2+1,1,K) = T6+T7 
         CHR(JJ,IDO/2+1,3,K) = T6-T7
         CHR(JJ,IDO/2+1,5,K) = CCR(JJ,IDO/2+1,K,1)-T5
         CHI(JJ,1,2,K) = -TI12*T2-TI11*T4
         CHI(JJ,1,4,K) = -TI11*T2+TI12*T4
  106 CONTINUE
      RETURN
      END









      SUBROUTINE VRFFTI (N,WSAVE,IFAIL)
      DIMENSION       WSAVE(N+15)
      IF (N .EQ. 1) THEN
        IFAILN=1
      ELSE
        CALL RFFTI1 (N,WSAVE(1),WSAVE(N+1),IFAILN)
      ENDIF
      IF(IFAIL.EQ.0.AND.IFAILN.NE.0) THEN
        IF(IFAILN.EQ.1) THEN
          WRITE(*,*) 'VRFFTI-ERROR-N MUST BE EVEN'
        ELSE
          WRITE(*,*) 'VRFFTI-ERROR-CANNOT FACTOR',IFAILN
        ENDIF
        STOP
      ENDIF
      IF(IFAIL.NE.0) IFAIL=IFAILN    
      RETURN
      END
      SUBROUTINE RFFTI1 (N,WA,IFAC,IFAIL)
      DIMENSION       WA(N),IFAC(15),NTRYH(4),NFAC(4)
      DATA NTRYH/2,3,4,5/
      IFAIL=0
      NL = N
      NF = 0
C FIRST FACTOR N, SELECT LARGE FACTORS FIRST
      DO 101 J=4,1,-1
        NFAC(J)=0
        NTRY=NTRYH(J)
 102    IF (NL.EQ.NL/NTRY*NTRY) THEN
          NL=NL/NTRY
          NF=NF+1
          NFAC(J)=NFAC(J)+1
          GOTO 102
        ENDIF
 101  CONTINUE
      IF(NL.NE.1) THEN
        IFAIL=NL
        RETURN
      ENDIF
C NOW INSERT THE FACTORS INTO IFAC WITH THE LARGEST EVEN FACTOR LAST
      IF(NFAC(3).GT.0) THEN
        IFAC(NF+2)=4
        NFAC(3)=NFAC(3)-1
      ELSE
        IF(NFAC(1).GT.0) THEN
          IFAC(NF+2)=2
          NFAC(1)=NFAC(1)-1
        ELSE
          IFAIL=1
          RETURN
        ENDIF
      ENDIF         
      NP=3
      DO 103 J=1,4
        DO 104 NP=NP,NP-1+NFAC(J)
          IFAC(NP)=NTRYH(J)
 104    CONTINUE
 103  CONTINUE
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END










      SUBROUTINE VSINT (X,W,N,M,INC,JMP,WSAVE)
      DIMENSION       X(1)       ,WSAVE(1)
      NP1 = N+1
      IW1 = N/2+1
      IW2 = IW1+NP1
      CALL SINT1(X,W,N,M,INC,JMP,WSAVE,WSAVE(IW1),WSAVE(IW2))
      RETURN
      END
      SUBROUTINE SINT1(X,W,N,M,INC,JMP,WAS,WAR,IFAC)
      DIMENSION WAR(1),WAS(1),X(INC,1),W(INC,1),IFAC(1)
      DATA SQRT3 /1.73205080756888/
      IF(N.EQ.1) THEN
        DO 200 J=1,M
          JJ=1+(J-1)*JMP
          X(JJ,1) = X(JJ,1)+X(JJ,1)
 200    CONTINUE
      ELSE
      NP1 = N+1
      NS2 = N/2
      DO 205 J=1,M
        JJ=1+(J-1)*JMP
        W(JJ,1) = 0.
 205  CONTINUE
      DO 104 K=1,NS2
        KC = NP1-K
CDIR$ IVDEP
        DO 202 J=1,M
          JJ=1+(J-1)*JMP
          T1 = X(JJ,K)-X(JJ,KC)
          T2 = WAS(K)*(X(JJ,K)+X(JJ,KC))
	  W(JJ,K+1) = T1+T2
	  W(JJ,KC+1) = T2-T1
  202   CONTINUE
  104 CONTINUE
      DO 203 J=1,M
        JJ=1+(J-1)*JMP
        W(JJ,NS2+2) = 4.*X(JJ,NS2+1)
 203  CONTINUE
      CALL RFFTF1 (W,W(1,2),X,X(1,2),NP1,M,2*INC,JMP,WAR,IFAC)
      DO 204 J=1,M
        JJ=1+(J-1)*JMP
        X(JJ,1) = .5*W(JJ,1)
 204  CONTINUE
      DO 105 I=3,N,2
CDIR$ IVDEP
      DO 105 J=1,M
         JJ=1+(J-1)*JMP
	 X(JJ,I-1) = -W(JJ,I+1)
	 X(JJ,I) = X(JJ,I-2)+W(JJ,I)
  105 CONTINUE
      RETURN
      ENDIF
      END

      SUBROUTINE VSINTI (N,WSAVE,IFAIL)
      DIMENSION       WSAVE(3*N/2+15)
      DATA PI /3.14159265358979/
      IFAILN=0
      IF (N .NE. 1) THEN
        NS2 = N/2
        NP1 = N+1
        DT = PI/FLOAT(NP1)
        DO 101 K=1,NS2
          WSAVE(K) = 2.*SIN(K*DT)
  101   CONTINUE
        CALL RFFTI1 (NP1,WSAVE(NS2+1),WSAVE(NS2+N+2),IFAILN)
        IF(IFAIL.EQ.0.AND.IFAILN.NE.0) THEN
          IF(IFAILN.EQ.1) THEN
            WRITE(*,*) 'VSINTI-ERROR-N MUST BE ODD'
          ELSE
            WRITE(*,*) 'VSINTI-ERROR-CANNOT FACTOR',IFAILN
          ENDIF
          STOP
        ENDIF
      ENDIF
      IF(IFAIL.NE.0) IFAIL=IFAILN    
      RETURN
      END

C	SUBROUTINE VISASUB
C********1*********2*********3*********4*********5*********6*********7**
C	IMPLICIT NONE
C	INCLUDE 'parameter3.f'
C	INCLUDE 'variabel3.f'
C	
C*********************************MAIN**********************************
C	IF(IT.EQ.0)THEN
C	   CALL READINPUT(T0,T,IT,CN,CNM1,CFLNUM,TMAX,
C    &                  ITMAX,IFN,K0,RE)
C	   CALL PAO(UC,ALFA,GAMMA,NX,NX,RE,K0,VISC)
C	   CALL INIT(NX,NZ,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
C	   CALL CALCOM(NX,NZ,ALFA,GAMMA,UC,OM2)
C	END IF
C
C	CALL STEP2A(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)		!Non-linear
C	IF(IFN.NE.0)CALL NEXTDT(NX,NZ,UR,CFLNUM,IT,IFN,DT,CN)
C	CALL STEP2B(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)		!Non-linear
C	CALL STEP3(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ,
C    &           OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1)		!One-diagonal
C	WRITE(*,'(I4,A,F12.9)')IT,'  T = ',T
C	
C	RETURN
C	END
C*********************************************************************
C*******************************SUBBS*********************************
C*********************************************************************
	SUBROUTINE READINPUT(T0,T,IT,CN,CNM1,CFLNUM,TMAX,ITMAX,IFN,K0,RE)
	IMPLICIT NONE
	INTEGER IT,ITMAX,IFN
	REAL    T0,T,TMAX,DT,CN,CNM1,CFLNUM,K0,RE
	T0=0
      T=T0
      IT=0
      CN=1
      CNM1=0
      CFLNUM=0.7
	TMAX=10
	DT=0
	ITMAX=10000
	IFN=1
	K0=10
	RE=500
	RETURN
	END			!READINPUT
C*********************************************************************
	SUBROUTINE INIT(NX,NZ,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
	IMPLICIT NONE
	INTEGER   NX,NZ
	COMPLEX   NOLL
	PARAMETER (NOLL=(0.00,0.00))
	COMPLEX   FNM1(NX/2,NZ)
	REAL      ALFA(NX/2),GAMMA(NZ) 
	REAL      PREX(3*NX/2+15),PREZ(3*NZ+15),WSAVE(NX+15)
	INTEGER   X,Z
	CALL VRFFTI(3*NX/2,PREX,0)
	CALL VRFFTI(NX,WSAVE,0)
	CALL VCFFTI(3*NZ/2,PREZ,0)
	DO 200 X=1,NX/2
	   ALFA(X)=FLOAT(X-1)
 200	CONTINUE
	GAMMA(1)=0.
	DO 300 Z=2,NZ/2+1
	   GAMMA(Z)=FLOAT(Z-1)
	   GAMMA(NZ+2-Z)=-GAMMA(Z)
 300	CONTINUE
	DO 400 X=1,NX/2
	   DO 500 Z=1,NZ
	      FNM1(X,Z)=NOLL
 500	   CONTINUE
 400	CONTINUE
	RETURN
	END			!INIT

C*************************************************************
	SUBROUTINE CALCOM(NX,NZ,ALFA,GAMMA,UC,OM2)
	IMPLICIT NONE
	INTEGER NX,NZ
      COMPLEX UC(3*NX/4+1,3*NZ/2,3),OM2(NX/2,NZ)
	REAL ALFA(NX/2),GAMMA(NZ)
	COMPLEX IM
	PARAMETER (IM=(0.00,1.00))
	INTEGER X,Z
C       calculate omega2_th spectrally
	DO 100 Z=1,NZ
	   DO 110 X=1,NX/2
	      OM2(X,Z)=IM*(GAMMA(Z)*UC(X,Z,1)-ALFA(X)*UC(X,Z,2))
 110	   CONTINUE
 100	CONTINUE

	RETURN
	END			!CALCOM

C***********************************************************************
	SUBROUTINE STEP2A(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)
	IMPLICIT NONE
	INTEGER NX,NZ
	COMPLEX UC(3*NX/4+1,3*NZ/2,3)
	REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	COMPLEX   NOLL
	PARAMETER (NOLL=(0.00,0.00))
	INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)

C       reshuffle and insert zeros in a-g-plane
	DO 100 I=1,2
	   DO 110 Z=1,3*NZ/2
	      DO 120 X=NX/2+1,3*NX/4+1
		     UC(X,Z,I)=NOLL
 120	      CONTINUE
 110	   CONTINUE
 100	CONTINUE

	DO 200 I=1,2
	   DO 210 Z=1,NZ/2
	      DO 220 X=1,NX/2
		     UC(X,Z+NZ,I)=UC(X,Z+NZ/2,I)
		     UC(X,Z+NZ/2,I)=NOLL
 220	      CONTINUE
 210	   CONTINUE
 200	CONTINUE

C       transform ui_h to phys space
	DO 500 I=1,2
	   CALL VCFFTB(UR(1,1,I),UR(2,1,I),TFFTXZ,TFFTXZ(2,1),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ)
	   CALL VRFFTB(UR(1,1,I),UR(2,1,I),TFFTXZ,TFFTXZ(2,1),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX)
 500	CONTINUE
C       ui now real and stored in UR(,,i)
	
	RETURN
	END

C***********************************************************************
	SUBROUTINE STEP2B(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ)
	IMPLICIT NONE
	INTEGER NX,NZ
	COMPLEX UC(3*NX/4+1,3*NZ/2,3)
	REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	COMPLEX   NOLL
	PARAMETER (NOLL=(0.00,0.00))
	INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)
C
C       calculate uiuj and put into UR(x,z,1-3)
	DO 700 Z=1,3*NZ/2
	   DO 710 X=1,3*NX/2
	      UR(X,Z,3)=UR(X,Z,1)*UR(X,Z,2)
	      UR(X,Z,1)=UR(X,Z,1)*UR(X,Z,1)
	      UR(X,Z,2)=UR(X,Z,2)*UR(X,Z,2)
 710	   CONTINUE
 700	CONTINUE

C       transform uiuj back to a-g space, i.e. to uiuj_th
	DO 800 I=1,3
	   CALL VRFFTF(UR(1,1,I),UR(2,1,I),TFFTXZ,TFFTXZ(2,1),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX)
	   CALL VCFFTF(UR(1,1,I),UR(2,1,I),TFFTXZ,TFFTXZ(2,1),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ)
 800	CONTINUE

C       put the 'extra' fourier coeff. to zero (the middle one)
	DO 900 I=1,3
	   DO 910 X=1,NX/2
	      UC(X,NZ+1,I)=NOLL
 910	   CONTINUE
 900	CONTINUE
	
	RETURN
	END			!STEP2
C***********************************************************************
	SUBROUTINE STEP3(NX,NZ,UC,UR,TFFTXZ,PREX,PREZ,
     &                 OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1)
	IMPLICIT NONE
	INTEGER NX,NZ
	COMPLEX UC(3*NX/4+1,3*NZ/2,3),OM2(NX/2,NZ),FNM1(NX/2,NZ)
	REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	REAL ALFA(NX/2),GAMMA(NZ)
	COMPLEX   NOLL,IM
	PARAMETER (NOLL=(0.00,0.00),IM=(0.00,1.00))
	COMPLEX FN
	REAL DIVXZ,K2,VT,VISC,T,DT,CN,CNM1
	INTEGER I,X,Z
C     EQUIVALENCE (UC,UR)
C
C       colve for omega2_th, u_th and w_th
C       in the first timestep FNM1=0 and the eulerstep is DT0

	DIVXZ=1./(FLOAT(3*NX/2)*FLOAT(3*NZ/2))
	VT=0.5*VISC*DT
	DO 100 Z=1,NZ/2
	   DO 110 X=1,NX/2
	      FN=(GAMMA(Z)*ALFA(X)*(UC(X,Z,1)-UC(X,Z,2))+
     &           UC(X,Z,3)*(GAMMA(Z)**2-ALFA(X)**2))*DIVXZ
	      K2=(ALFA(X)**2+GAMMA(Z)**2)
	      OM2(X,Z)=(OM2(X,Z)*(1-VT*K2)+
     &             DT*0.5*((2+CNM1)*FN-CNM1*FNM1(X,Z)))/(1+VT*K2)
	      FNM1(X,Z)=FN	!save fn for next time step
 110	   CONTINUE
 100	CONTINUE

	DO 200 Z=NZ/2+1,NZ
	   DO 210 X=1,NX/2
	      FN=(GAMMA(Z)*ALFA(X)*(UC(X,Z+NZ/2,1)-UC(X,Z+NZ/2,2))+
     &           UC(X,Z+NZ/2,3)*(GAMMA(Z)**2-ALFA(X)**2))*DIVXZ
	      K2=(ALFA(X)**2+GAMMA(Z)**2)
	      OM2(X,Z)=(OM2(X,Z)*(1-VT*K2)+
     &             DT*0.5*((2+CNM1)*FN-CNM1*FNM1(X,Z)))/(1+VT*K2)
	      FNM1(X,Z)=FN	!save fn for next time step
 210	   CONTINUE
 200	CONTINUE

      CNM1=CN                 !save cn for next time step

	DO 300 Z=1,NZ
	   DO 310 X=2,NX/2
	      K2=(ALFA(X)**2+GAMMA(Z)**2)
	      UC(X,Z,1)=-IM*GAMMA(Z)*OM2(X,Z)/K2
	      UC(X,Z,2)=IM*ALFA(X)*OM2(X,Z)/K2
 310	   CONTINUE
 300	CONTINUE

	DO 400 Z=2,NZ           !X=1
	   UC(1,Z,1)=-IM*OM2(1,Z)/GAMMA(Z)
	   UC(1,Z,2)=NOLL
 400	CONTINUE

      UC(1,1,1)=NOLL
	UC(1,1,2)=NOLL
      T=T+DT

	RETURN
	END			!STEP3

C***********************************************************************
	SUBROUTINE NEXTDT(NX,NZ,UR,CFLNUM,IT,IFN,DT,CN)
	IMPLICIT NONE
	INTEGER NX,NZ,IT,IFN
	REAL UR(3*NX/2+2,3*NZ/2,3)
	REAL PI,CFLM,DX,DZ,CFL,CFLNUM,DT,CN
	PARAMETER (PI=3.14159265358979)
	INTEGER X,Z
C       calculates the next time step
      CFLM=0

      IF((IT.EQ.0).AND.(DT.EQ.0))THEN
        DX=2*PI/FLOAT(NX)
        DZ=2*PI/FLOAT(NZ)
        DO 100 Z=1,3*NZ/2
		  DO 110 X=1,3*NX/2
			  CFLM=MAX(CFLM,ABS(UR(X,Z,1))/DX+ABS(UR(X,Z,2))/DZ)
 110		  CONTINUE
 100    CONTINUE
	  DT=CFLNUM/CFLM/PI
	  RETURN
	END IF

	IF(MOD(IT,IFN).EQ.0)THEN
        DX=2*PI/FLOAT(NX)
        DZ=2*PI/FLOAT(NZ)
        DO 200 Z=1,3*NZ/2
		  DO 210 X=1,3*NX/2
			  CFLM=MAX(CFLM,ABS(UR(X,Z,1))/DX+ABS(UR(X,Z,2))/DZ)
 210		  CONTINUE
 200    CONTINUE
        CFL=CFLM*DT*PI
	  CN=0.8+0.2*CFLNUM/CFL
        DT=DT*CN
	  RETURN
	END IF

	RETURN
	END			!NEXTDT
C***********************************************************************
	SUBROUTINE FIELD2PIX(PIXARR,PX,PY,UR,ENFAC,NX3D2,NZ3D2,AXIS)
	IMPLICIT NONE
	INTEGER  NX3D2, NZ3D2, PX, PY, SIZE, AXIS
	REAL	 UR(NX3D2+2,NZ3D2,3)
	INTEGER  PIXARR(PX,PY)
	INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
	REAL     ENFAC
	!C
	!C	32-bit Grayscale
	!C
	GRAY  = (1+256+65536)
	SCALE = MIN(PX/NX3D2,PY/NZ3D2)
	DO I=1,NX3D2
		DO J=1,NZ3D2
			PIXEL = MAX(1,MIN(255,(INT(ENFAC*UR(I,J,AXIS))+128)))*GRAY
			DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
				DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
					PIXARR(II,JJ) = PIXEL
				END DO
			END DO
		END DO
	END DO

	RETURN
	END			!FIELD2PIX

C***********************************************************************
	SUBROUTINE FIELD2KIN(PIXARR,PX,PY,UR,KEFAC,NX3D2,NZ3D2)
	IMPLICIT NONE
	INTEGER  NX3D2, NZ3D2, PX, PY, SIZE
	REAL	 UR(NX3D2+2,NZ3D2,3)
	INTEGER  PIXARR(PX,PY)
	INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
	REAL     KEFAC, U2, W2, K
	!C
	!C	32-bit Grayscale
	!C
	GRAY  = (1+256+65536)
	SCALE = MIN(PX/NX3D2,PY/NZ3D2)
	DO I=1,NX3D2
		DO J=1,NZ3D2
			   U2 = UR(I,J,1)**2
			   W2 = UR(I,J,2)**2
				K = SQRT(U2+W2)
			PIXEL = MAX(1,MIN(255,(INT(KEFAC*K))))*GRAY
			DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
				DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
					PIXARR(II,JJ) = PIXEL
				END DO
			END DO
		END DO
	END DO

	RETURN
	END			!FIELD2KIN

C***********************************************************************
	SUBROUTINE OM2PHYS(NX,NZ,UC,UR,OM2,TFFTXZ,PREX,PREZ)
	IMPLICIT NONE
	INTEGER NX,NZ
	COMPLEX OM2(NX/2,NZ)
	COMPLEX UC(3*NX/4+1,3*NZ/2,3)
	REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	COMPLEX   NOLL
	PARAMETER (NOLL=(0.00,0.00))
	INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C	Copy omega
	DO 10 Z=1,NZ
	  DO 20 X=1,NX/2
	    UC(X,Z,3) = OM2(X,Z)
20	  CONTINUE
10	CONTINUE

C     reshuffle and insert zeros in a-g-plane
	DO 110 Z=1,3*NZ/2
	  DO 120 X=NX/2+1,3*NX/4+1
		UC(X,Z,3) = NOLL
 120	  CONTINUE
 110	CONTINUE

	DO 210 Z=1,NZ/2
	  DO 220 X=1,NX/2
		UC(X,Z+NZ,3)   = UC(X,Z+NZ/2,3)
		UC(X,Z+NZ/2,3) = NOLL
 220	  CONTINUE
 210	CONTINUE

	DO 910 X=1,NX/2
	  UC(X,NZ+1,3)=NOLL
 910	CONTINUE

C       transform omega to phys space
	CALL VCFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ,TFFTXZ(2,1),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ)
	CALL VRFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ,TFFTXZ(2,1),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX)
	
	RETURN
	END			!OM2PHYS

C***********************************************************************
	SUBROUTINE FIELD2PHI(PIXARR,PX,PY,UR,OMFAC,NX3D2,NZ3D2,AXIS)
	IMPLICIT NONE
	INTEGER  NX3D2, NZ3D2, PX, PY, SIZE, AXIS
	REAL	 UR(NX3D2+2,NZ3D2,3)
	INTEGER  PIXARR(PX,PY)
	INTEGER  GRAY, I, J, II, JJ, PIXEL, SCALE
	REAL     OMFAC
	!C
	!C	32-bit Grayscale
	!C
	GRAY  = (1+256+65536)
	SCALE = MIN(PX/NX3D2,PY/NZ3D2)
	DO I=1,NX3D2
		DO J=1,NZ3D2
			PIXEL = MAX(1,MIN(255,(INT(OMFAC*UR(I,J,AXIS)))))*GRAY
			DO II = SCALE*(I-1)+1,SCALE*(I-1)+SCALE
				DO JJ = SCALE*(J-1)+1,SCALE*(J-1)+SCALE
					PIXARR(II,JJ) = PIXEL
				END DO
			END DO
		END DO
	END DO

	RETURN
	END			!FIELD2OMG

C***********************************************************************
	SUBROUTINE PHIPHYS(NX,NZ,ALFA,GAMMA,UC,UR,TFFTXZ,PREX,PREZ)
	IMPLICIT NONE
	INTEGER NX,NZ
	REAL ALFA(NX/2),GAMMA(NZ)
	COMPLEX UC(3*NX/4+1,3*NZ/2,3)
	REAL UR(3*NX/2+2,3*NZ/2,3)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	REAL K2
	COMPLEX   NOLL, IM
	PARAMETER (NOLL=(0.00,0.00))
	PARAMETER (IM=(0.00,1.00))
	INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C	Calculate phi
	DO 10 Z=2,NZ
	  DO 20 X=2,NX/2
	    UC(X,Z,3) = -IM/(2*ALFA(X)*GAMMA(Z))*
     &                (GAMMA(Z)*UC(X,Z,1) + ALFA(X)*UC(X,Z,2))
20	  CONTINUE
10	CONTINUE
	UC(1,1,3)=NOLL

	DO 30 X=2,NX/2
	    UC(X,1,3) = -IM/ALFA(X)*UC(X,1,1)
30	CONTINUE

	DO 40 Z=2,NZ
	    UC(1,Z,3) = -IM/GAMMA(Z)*UC(1,Z,2)
40	CONTINUE



C     reshuffle and insert zeros in a-g-plane
	DO 110 Z=1,3*NZ/2
	  DO 120 X=NX/2+1,3*NX/4+1
		UC(X,Z,3) = NOLL
 120	  CONTINUE
 110	CONTINUE

	DO 210 Z=1,NZ/2
	  DO 220 X=1,NX/2
		UC(X,Z+NZ,3)   = UC(X,Z+NZ/2,3)
		UC(X,Z+NZ/2,3) = NOLL
 220	  CONTINUE
 210	CONTINUE

	DO 910 X=1,NX/2
	  UC(X,NZ+1,3)=NOLL
 910	CONTINUE

C       transform omega to phys space
	CALL VCFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ,TFFTXZ(2,1),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ)
	CALL VRFFTB(UR(1,1,3),UR(2,1,3),TFFTXZ,TFFTXZ(2,1),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX)
	
	RETURN
	END			!PHIPHYS
C***********************************************************************
	SUBROUTINE STREAMFUNC(NX,NZ,ALFA,GAMMA,UC,UR,OM2,TFFTXZ,PREX,PREZ)
	IMPLICIT NONE
	INTEGER NX,NZ
	REAL ALFA(NX/2),GAMMA(NZ)
	COMPLEX OM2(NX/2,NZ)
	COMPLEX UC(3*NX/4+1,3*NZ/2,4)
	REAL UR(3*NX/2+2,3*NZ/2,4)
      REAL TFFTXZ(3*NX/2+2,3*NZ/2),PREX(3*NX/2+15),PREZ(3*NZ+15)
	REAL K2
	COMPLEX   NOLL, IM
	PARAMETER (NOLL=(0.00,0.00))
	PARAMETER (IM=(0.00,1.00))
	INTEGER I,X,Z
C      EQUIVALENCE (UC,UR)

C	Calculate Streamfunction
	DO 10 Z=1,NZ
	  DO 20 X=1,NX/2
			   K2 = ALFA(X)**2 + GAMMA(Z)**2
		UC(X,Z,4) = OM2(X,Z)/(K2 + 1.0E-30)
20	  CONTINUE
10	CONTINUE
	UC(1,1,4)=NOLL


C     reshuffle and insert zeros in a-g-plane
	DO 110 Z=1,3*NZ/2
	  DO 120 X=NX/2+1,3*NX/4+1
		UC(X,Z,4) = NOLL
 120	  CONTINUE
 110	CONTINUE

	DO 210 Z=1,NZ/2
	  DO 220 X=1,NX/2
		UC(X,Z+NZ,4)   = UC(X,Z+NZ/2,4)
		UC(X,Z+NZ/2,4) = NOLL
 220	  CONTINUE
 210	CONTINUE

	DO 910 X=1,NX/2
	  UC(X,NZ+1,4)=NOLL
 910	CONTINUE

C       transform omega to phys space
	CALL VCFFTB(UR(1,1,4),UR(2,1,4),TFFTXZ,TFFTXZ(2,1),
     &                 3*NZ/2,NX/2,3*NX/2+2,2,PREZ)
	CALL VRFFTB(UR(1,1,4),UR(2,1,4),TFFTXZ,TFFTXZ(2,1),
     &                 3*NX/2,3*NZ/2,2,3*NX/2+2,PREX)
	
	RETURN
	END			!STREAMFUNC

      PROGRAM RUN_DNS
C***********************************************************************
C  Simple diagnostic harness for the legacy DNS routines (visasub.f)
C  Updated: 100 iterations, log every 10th step, report FPS at the end.
C***********************************************************************

      IMPLICIT NONE
      INTEGER N, N3D2, PX, PY
      PARAMETER (N = 256)
      PARAMETER (N3D2 = 3*N/2)
      PARAMETER (PX = N3D2*2)
      PARAMETER (PY = N3D2*2)

C     Arrays
      COMPLEX   UC(1+3*N/4,3*N/2,3)
      COMPLEX   OM2(N/2,N)
      COMPLEX   FNM1(N/2,N)
      REAL      ALFA(N/2), GAMMA(N)
      REAL      TFFTXZ(2+3*N/2,3*N/2,4)
      REAL      PREX(15+3*N/2,4)
      REAL      PREZ(15+3*N,4)
      REAL      WSAVE(15+N)
      REAL      UR(2+3*N/2,3*N/2,3)
      INTEGER   PIXARR(PX,PY), STEPS

      EQUIVALENCE (UC,UR)

C     Scalars
      REAL      RE, K0, VISC, T, DT, CN, CNM1, CFLNUM
      INTEGER   IT, IFN, NE

C     Timing for FPS (using standard CPU_TIME)
      REAL      TBEGIN, TEND, ELAP, FPS, ELAP2
      INTEGER COUNT_RATE, START, FINISH
      INTEGER START2, FINISH2, COUNT_RATE2, COUNT_MAX, TICKS
      CALL SYSTEM_CLOCK(START2, COUNT_RATE2, COUNT_MAX)

      NE = N
      RE = 1000.0
      K0 = 10.0
      VISC = 1.0/RE
      T = 0.0
      DT = 0.0
      CN = 1.0
      CNM1 = 0.0
      CFLNUM = 0.75
      IT = 0
      IFN = 1

      WRITE(*,*) '--- INITIALIZING DNS3D ---'
      WRITE(*,*) 'N=',N

C===== Initialization sequence =========================================

C 1. PAO
      CALL PAO(UC,ALFA,GAMMA,N,NE,RE,K0,VISC)
      WRITE(*,*) 'After PAO: VISC=',VISC
      WRITE(*,*) '  Max |UC|=',MAXVAL(ABS(UC))

C 2. INIT
      CALL INIT(N,N,ALFA,GAMMA,FNM1,PREX,PREZ,WSAVE)
      WRITE(*,*) 'After INIT  Max(ALFA)=',MAXVAL(ALFA),
     &           ' Max(GAMMA)=',MAXVAL(GAMMA)

C 3. CALCOM
      CALL CALCOM(N,N,ALFA,GAMMA,UC,OM2)
      WRITE(*,*) 'After CALCOM  Max |OM2|=',MAXVAL(ABS(OM2))

C 4. STEP2A
      CALL STEP2A(N,N,UC,UR,TFFTXZ,PREX,PREZ)
      WRITE(*,*) 'Max |UC| before STEP2A =', MAXVAL(ABS(UC))
      WRITE(*,*) 'Max |UR| after STEP2A  =', MAXVAL(ABS(UR))

C===== Time stepping ===================================================

      CALL NEXTDT(N,N,UR,CFLNUM,IT,IFN,DT,CN)
      WRITE(*,*) 'Initial DT=',DT,' CN=',CN

C     Start timing before the main loop
      CALL CPU_TIME(TBEGIN)
      CALL SYSTEM_CLOCK(START2)

C     1000 time steps, log every 10th step
      STEPS = 1000
      DO 100 IT=1,STEPS
         CALL STEP2B(N,N,UC,UR,TFFTXZ,PREX,PREZ)
         CALL STEP3(N,N,UC,UR,TFFTXZ,PREX,PREZ,
     &              OM2,ALFA,GAMMA,FNM1,VISC,T,DT,CN,CNM1)
         CALL STEP2A(N,N,UC,UR,TFFTXZ,PREX,PREZ)
         CALL NEXTDT(N,N,UR,CFLNUM,IT,IFN,DT,CN)

         IF (MOD(IT,100) .EQ. 0) THEN
            WRITE(*,*) 'Step',IT,' T=',T,' DT=',DT,' CN=',CN
         END IF
  100 CONTINUE

C     Stop timing after the loop and compute FPS
      CALL CPU_TIME(TEND)
      ELAP = TEND - TBEGIN
      IF (ELAP .GT. 0.0) THEN
         FPS = REAL(STEPS) / ELAP
      ELSE
         FPS = 0.0
      END IF

      WRITE(*,*) 'Elapsed CPU time for 100 steps (s) =', ELAP
      WRITE(*,*) 'Frames per second (FPS)            =', FPS

      CALL SYSTEM_CLOCK(FINISH2)
      TICKS = FINISH2 - START2
      IF (TICKS .LT. 0) TICKS = TICKS + COUNT_MAX
      ELAP2= FLOAT(TICKS) / FLOAT(COUNT_RATE2)
      PRINT *, 'Elapsed time (s): ', ELAP2
      PRINT *, 'FPS: ', REAL(STEPS) / ELAP2

C===== Visualization / sanity checks ===================================

      CALL FIELD2PIX(PIXARR,PX,PY,UR,75.0,N3D2,N3D2,1)
      CALL FIELD2PIX(PIXARR,PX,PY,UR,75.0,N3D2,N3D2,2)
      CALL FIELD2PIX(PIXARR,PX,PY,UR,75.0,N3D2,N3D2,3)
      CALL FIELD2KIN(PIXARR,PX,PY,UR,125.0,N3D2,N3D2)
      CALL OM2PHYS(N,N,UC,UR,OM2,TFFTXZ,PREX,PREZ)

      WRITE(*,*) 'Pixels sample:',PIXARR(1,1),PIXARR(64,64)
      WRITE(*,*) 'Final T=',T,' CN=',CN,' DT=',DT,' VISC=',VISC
      WRITE(*,*) 'Final Max |UR|=',MAXVAL(ABS(UR))
      WRITE(*,*) 'Final Max |OM2|=',MAXVAL(ABS(OM2))
      WRITE(*,*) 'Final Max |PIXARR|=',MAXVAL(ABS(PIXARR))


      END

#!/bin/bash

set -euo pipefail

# Fortran compiler + flags
export FC=${FC:-gfortran}
export FFLAGS="-Ofast -mcpu=native -funroll-loops -std=legacy \
  -ffixed-line-length-none -fno-automatic -finit-local-zero \
  -fallow-argument-mismatch"

# Force NumPy/distutils to use the normal gcc instead of aarch64-linux-gnu-gcc
export CC=${CC:-gcc}
export CXX=${CXX:-g++}

# Optional: sanity check
if ! command -v "$CC" >/dev/null 2>&1; then
  echo "ERROR: C compiler '$CC' not found in PATH"
  exit 1
fi

# Clean previous build artifacts (Linux suffix)
rm -f dns_fortran*.so

python -m numpy.f2py -c \
  --compiler=unix \
  --fcompiler=gnu95 \
  dns_fortran_min.pyf \
  pao.f vfft.f visasub.f dns_driver_min.f

python -c "import dns_fortran; dns_fortran.run_dns(1000.0, 10.0)"
echo "Done!"

#!/bin/bash

rm fortran_test.exe
rm *.o

FFLAGS_COMMON="-std=legacy -ffixed-line-length-none -Wno-tabs -fno-automatic -finit-local-zero -fallow-argument-mismatch"
FFLAGS="$FFLAGS_COMMON -O0 -g"

gfortran $FFLAGS -c pao.f dns.f vfft.f visasub.f
gfortran $FFLAGS -o fortran_test.exe pao.o dns.o vfft.o visasub.o
./fortran_test.exe

#!/bin/bash

set -euo pipefail

export FC=gfortran

# Common flags for old F77 / fixed-form
COMMON="-std=legacy -ffixed-line-length-none -Wno-tabs \
  -fallow-argument-mismatch -w"

# DNS / driver code: legacy semantics (SAVE-like locals)
DNS_FLAGS="$COMMON -fno-automatic -finit-local-zero \
  -Ofast -mcpu=native -funroll-loops -flto -fopenmp"

# FFT library: needs automatic locals for thread safety
VFFT_FLAGS="$COMMON -frecursive \
  -Ofast -mcpu=native -funroll-loops -flto -fopenmp"

# Find where libgomp lives and link to it explicitly
LIBGOMP_PATH=$(gfortran -print-file-name=libgomp.dylib)
LIBGOMP_DIR=$(dirname "$LIBGOMP_PATH")

# Link against libgomp, and add rpath so macOS can find it at runtime
export LDFLAGS="-L${LIBGOMP_DIR} -lgomp -Wl,-rpath,${LIBGOMP_DIR}"

# Tell NumPy to append (not overwrite) flags
export NPY_DISTUTILS_APPEND_FLAGS=1

# Runtime OpenMP threads
export OMP_NUM_THREADS=4
export OMP_DISPLAY_ENV=TRUE

rm -f dns_fortran*.so *.o

echo "Compiling Fortran objects with OpenMP..."

# vfft: compiled separately, re-entrant
$FC $VFFT_FLAGS -c vfft.f

# DNS core + driver: with -fno-automatic
$FC $DNS_FLAGS  -c pao.f visasub3d.f dns_driver_min3d.f

echo "Building f2py module dns_fortran (with OpenMP)..."

python -m numpy.f2py -c \
  dns_fortran_min.pyf \
  pao.o visasub3d.o dns_driver_min3d.o vfft.o \
  -lgomp

python -c "import dns_fortran; dns_fortran.run_dns(1000.0, 10.0)"
echo "Done!"

#!/bin/bash

set -euo pipefail

# Python interpreter (your 3.13 venv)
PYTHON=${PYTHON:-python3.13}

# Compilers
export FC=${FC:-/opt/homebrew/bin/gfortran}
export CC=${CC:-clang}
export CXX=${CXX:-clang++}

# Source dir (where this script and libvfft.a live)
SRC_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"

# -----------------------------
#  Fortran flags
# -----------------------------
# Common flags for old F77 / fixed-form
COMMON="-std=legacy -ffixed-line-length-none -Wno-tabs \
  -fallow-argument-mismatch -w -fPIC"

# DNS / driver code: legacy semantics + OpenMP
DNS_FFLAGS="$COMMON -frecursive -fno-automatic -finit-local-zero \
  -Ofast -mcpu=native -funroll-loops -fopenmp"

# FFT library: NO OpenMP (thread-unsafe), still recursive + optimized
VFFT_FFLAGS="$COMMON -frecursive \
  -Ofast -mcpu=native -funroll-loops"

# Tell f2py/meson to use DNS_FFLAGS for all Fortran it compiles itself
export FFLAGS="$DNS_FFLAGS"

# -----------------------------
#  OpenMP runtime (libgomp)
# -----------------------------
LIBGOMP_PATH="$($FC -print-file-name=libgomp.dylib)"
LIBGOMP_DIR="$(dirname "$LIBGOMP_PATH")"

# Only libgomp in LDFLAGS (this combo has worked before)
export LDFLAGS="-L${LIBGOMP_DIR} -lgomp -Wl,-rpath,${LIBGOMP_DIR}"

# Runtime OpenMP knobs
export OMP_NUM_THREADS=${OMP_NUM_THREADS:-4}
export OMP_DISPLAY_ENV=${OMP_DISPLAY_ENV:-TRUE}

echo "Using Python:           $PYTHON"
echo "Using Fortran compiler: $FC ($(command -v "$FC"))"
echo "Using C compiler:       $CC ($(command -v "$CC"))"
echo "Using C++ compiler:     $CXX ($(command -v "$CXX"))"
echo "SRC_DIR:                $SRC_DIR"
echo "FFLAGS (DNS):           $FFLAGS"
echo "VFFT_FFLAGS:            $VFFT_FFLAGS"
echo "LDFLAGS:                $LDFLAGS"
echo "libgomp path:           $LIBGOMP_PATH"

# -----------------------------
#  Clean old build artefacts
# -----------------------------
rm -f "$SRC_DIR"/dns_fortran*.so "$SRC_DIR"/vfft.o "$SRC_DIR"/libvfft.a

# -----------------------------
#  Compile vfft.f WITHOUT OpenMP and archive into libvfft.a
# -----------------------------
echo "Compiling vfft.f (NO OpenMP)..."
"$FC" $VFFT_FFLAGS -c "$SRC_DIR"/vfft.f -o "$SRC_DIR"/vfft.o

echo "Creating static library libvfft.a..."
ar rcs "$SRC_DIR"/libvfft.a "$SRC_DIR"/vfft.o

# -----------------------------
#  Build dns_fortran via f2py/meson
#  - f2py compiles pao/visasub3d/dns_driver_min3d with OpenMP (FFLAGS)
#  - vfft code is pulled in from libvfft.a via -L<SRC_DIR> -lvfft
# -----------------------------
echo "Building f2py module dns_fortran (DNS with OpenMP, vfft serial)..."

"$PYTHON" -m numpy.f2py -c \
  "$SRC_DIR"/dns_fortran_min.pyf \
  "$SRC_DIR"/pao.f "$SRC_DIR"/visasub3d.f "$SRC_DIR"/dns_driver_min3d.f \
  -L"$SRC_DIR" -lvfft

# -----------------------------
#  Quick sanity check
# -----------------------------
echo "Running quick sanity check..."
"$PYTHON" -c "import dns_fortran; dns_fortran.run_dns(1000.0, 10.0)"
echo "Done!"

#!/bin/bash

rm dns3d.exe
rm *.o

export OMP_DISPLAY_ENV=TRUE
export OMP_NUM_THREADS=4
# export OMP_SCHEDULE=STATIC

FFLAGS_COMMON="-std=legacy -ffixed-line-length-none -Wno-tabs -fno-automatic -finit-local-zero -fallow-argument-mismatch"
FFLAGS="$FFLAGS_COMMON -Ofast -mcpu=native"

# vfft: compiled separately, re-entrant
gfortran -std=legacy -ffixed-line-length-none -Wno-tabs -frecursive -Ofast -mcpu=native -c vfft.f

# rest of code with your usual flags + OpenMP
gfortran $FFLAGS -c pao.f dns3d.f visasub3d.f

# link
gfortran -Ofast -mcpu=native -o dns3d_nomp.exe pao.o dns3d.o visasub3d.o vfft.o
./dns3d_nomp.exe

#!/bin/bash

export FC=gfortran
export FFLAGS="-Ofast -mcpu=native -funroll-loops -std=legacy \
  -ffixed-line-length-none -fno-automatic -finit-local-zero \
  -fallow-argument-mismatch"

# If you still want to completely silence warnings, you can optionally add:
#  -w -Wno-tabs
# to FFLAGS, e.g.:
# export FFLAGS="$FFLAGS -w -Wno-tabs"

rm -f dns_fortran.cpython-313-darwin.so

python -m numpy.f2py -c dns_fortran_min.pyf pao.f vfft.f visasub.f dns_driver_min.f

python -c "import dns_fortran; dns_fortran.run_dns(1000.0, 10.0)"
echo "Done!"
